(game-module "bellum2-rul"
    (blurb "Rule set for the Bellum Aeternum games.")
)

(include "bellum2-t")
(include "bellum2-u")

;; Terrain Materials

; TMAT_GENERAL
(table terrain-production
    ; Default: 0
)

;; Unit Materials

#|
    Land units store:
        cnc * 2 turns (special-ops, spies * 5 turns)
        fuelL * 3 turns (truck-convoy * 10 turns)
        psup * 3 turns (ditto)
        msup * 3 turns (ditto)
    Sea units store:
        cnc * 2 turns (submarine * 5)
        fuelS * 10 turns (supply-ship * 30 turns)
        psup * 10 turns (ditto)
        msup * 10 turns (ditto)
    Air units store:
        cnc * 2 turns (spy-planes * 3 turns)
        fuelA * 1 turn (bombers, cargo-planes, spy-planes * 3 turns)
        psup * 1 turn (ditto)
        msup * 1 turn (ditto)

    cnc Production (sums * 50%):
        field-hq:   2 paratroops, 2 marines, 4 armor, 2 cavalry, 6 mechinf, 
                    4 infantry, 4 artillery, 2 aaa, 2 engineers, 
                    4 truck-convoys, 2 dive-bombers, 4 fighters
        command-ship:   1 submarine, 2 cruisers, 2 destroyers, 2 frigates, 
                        2 mineships, 4 torp-boats, 2 escort-carriers, 
                        1 light-carrier, 2 troopships, 2 amphib-ships, 
                        2 supply-ships, 1 tugboat, 2 dive-bombers, 
                        2 torp-bombers, 2 fighters
        battleship: 2 cruisers, 2 destroyers, 2 frigates, 2 troopships, 
                    2 amphib-ships
        carrier:    1 cruiser, 1 destroyer, 1 frigate, 1 escort-carrier, 
                    1 dive-bombers, 1 torp-bombers, 2 fighters
        citadel:    4 special-ops, 2 germinators, 4 engineers, 4 spies, 
                    4 submarines, 10 escort-fighters, 10 bombers, 
                    4 spy-planes, 4 cargo-planes, 20 towns, 4 cities, 
                    1 metropolis
        capitol:    (citadel * 5)
|#

; UMAT_GENERAL
(table unit-storage-x
    ; Default: 0
)
(table base-production
    ; Default: 0
)
(table base-consumption
    ; Default: 0
)
(table consumption-as-occupant
    ; Default: 100%
)
(table hp-per-starve
    ; Default: 0.00
)
(table gives-to-treasury
    ; Default: false
)
(table takes-from-treasury
    ; Default: false
)
(table in-length
    ; Default: 0
)
(table out-length
    ; Default: 0
)

; UMAT_CITY_U
(table unit-storage-x add
    ; TODO: Better recalculate storage capacities.
    (indu-city-u* cnc (50 200 1000))
    (govt-city-u* cnc (2500 12500))
#|
    ; Settlers and recruits are provided to treasury.
    ; TODO: Make Xconq send treasury materials directly to treasury.
    (indu-city-u* settlers (0 2 10))
    (govt-city-u* settlers (4 20))
    (indu-city-u* recruits (1 4 20))
    (govt-city-u* recruits (8 40))
|#
    (indu-city-u* bulk (100 400 2000))
    (govt-city-u* bulk (400 2000))
    (indu-city-u* cmat (50 200 1000))
    (govt-city-u* cmat (200 1000))
    (indu-city-u* vehicles (125 500 2500))
    (govt-city-u* vehicles (500 2500))
    (indu-city-u* equipment (250 1000 5000))
    (govt-city-u* equipment (1000 5000))
    (indu-city-u* psup (500 2000 10000))
    (govt-city-u* psup (2000 10000))
    (indu-city-u* msup (1000 4000 20000))
    (govt-city-u* msup (4000 20000))
)
(table base-production add
    ; TODO: Better recalculate production rates.
    (govt-city-u* cnc (500 2500))
    (indu-city-u* settlers (0 2 10))
    (govt-city-u* settlers (4 20))
    (indu-city-u* recruits (1 4 20))
    (govt-city-u* recruits (8 40))
    (indu-city-u* bulk (20 80 400))
    (govt-city-u* bulk (80 400))
    (indu-city-u* cmat (10 40 200))
    (govt-city-u* cmat (40 200))
    (indu-city-u* vehicles (25 100 500))
    (govt-city-u* vehicles (100 500))
    (indu-city-u* equipment (50 200 1000))
    (govt-city-u* equipment (200 1000))
    (indu-city-u* psup (100 400 2000))
    (govt-city-u* psup (400 2000))
    (indu-city-u* msup (200 800 4000))
    (govt-city-u* msup (800 4000))
)
(table gives-to-treasury add
    (city-u* (settlers recruits) true)
    (ruins (settlers recruits) false)
)
(table in-length add
    (indu-city-u* cnc (20 30 30))
)
(table out-length add
    (govt-city-u* cnc 30)
    (indu-city-u* bulk (20 30 30))
    (govt-city-u* bulk 30)
    (indu-city-u* cmat (20 30 30))
    (govt-city-u* cmat 30)
    (indu-city-u* vehicles (20 30 30))
    (govt-city-u* vehicles 30)
    (indu-city-u* equipment (20 30 30))
    (govt-city-u* equipment 30)
    (indu-city-u* psup (20 30 30))
    (govt-city-u* psup 30)
    (indu-city-u* msup (20 30 30))
    (govt-city-u* msup 30)
)

; UMAT_FACILITY_U
(table unit-storage-x add
    ; TODO: Better recalculate storage capacities.
    (forts1 cnc 10)
    (forts2 cnc 30)
    (forts3 cnc 50)
    (level1-base-u* cnc 20)
    (level2-base-u* cnc 50)
    (level3-base-u* cnc 80)
    (refinery-u* cnc (5 10))
    (forts1 fuelL 10)
    (forts2 fuelL 50)
    (forts3 fuelL 100)
    (camp1 fuelL 20)
    (camp2 fuelL 100)
    (camp3 fuelL 200)
    (airbase1 fuelL 10)
    (airbase2 fuelL 50)
    (airbase3 fuelL 100)
    (seabase1 fuelL 10)
    (seabase2 fuelL 50)
    (seabase3 fuelL 100)
    ; TODO: Better calculate refinery-u* capacities.
    (refinery1 fuelL 250)
    (refinery2 fuelL 2500)
    (seabase1 fuelS 20)
    (seabase2 fuelS 100)
    (seabase3 fuelS 200)
    ; TODO: Better calculate refinery-u* capacities.
    (refinery1 fuelS 250)
    (refinery2 fuelS 2500)
    (airbase1 fuelA 100)
    (airbase2 fuelA 500)
    (airbase3 fuelA 1000)
    ; TODO: Better calculate refinery-u* capacities.
    (refinery1 fuelA 1250)
    (refinery2 fuelA 12500)
    (forts1 psup 10)
    (forts2 psup 50)
    (forts3 psup 100)
    (level1-base-u* psup 20)
    (level2-base-u* psup 100)
    (level3-base-u* psup 200)
    (forts1 msup 20)
    (forts2 msup 100)
    (forts3 msup 200)
    (level1-base-u* msup 40)
    (level2-base-u* msup 200)
    (level3-base-u* msup 400)
    ((forts1 camp1 airbase1) bulk 4)
    ((forts2 camp2 airbase2) bulk 20)
    ((forts3 camp3 airbase3) bulk 40)
    (seabase1 bulk 10)
    (seabase2 bulk 50)
    (seabase3 bulk 100)
    (refinery-u* bulk (5 15))
    (forts1 cmat 4)
    (forts2 cmat 20)
    (forts3 cmat 40)
    (level1-base-u* cmat 10)
    (level2-base-u* cmat 50)
    (level3-base-u* cmat 100)
    (refinery-u* cmat (5 15))
    ((camp1 airbase1) vehicles 10)
    ((camp2 airbase2) vehicles 50)
    ((camp3 airbase3) vehicles 100)
    (seabase1 vehicles 4)
    (seabase2 vehicles 20)
    (seabase3 vehicles 40)
    (level1-base-u* equipment 20)
    (level2-base-u* equipment 100)
    (level3-base-u* equipment 200)
)
(table base-production add
    ; TODO: Better calculate refinery-u* production.
    (refinery1 fuelL 50)
    (refinery2 fuelL 500)
    (refinery1 fuelS 50)
    (refinery2 fuelS 500)
    (refinery1 fuelA 250)
    (refinery2 fuelA 2500)
    (airbase2 pilots 1)
    (airbase3 pilots 4)
)
(table base-consumption add
    (airbase2 recruits 1)
    (airbase3 recruits 4)
    (refinery1 cnc 1)
    (refinery2 cnc 5)
)
(table gives-to-treasury add
    (airbase-u* pilots true)
)
(table takes-from-treasury add
    (base-u* recruits true)
    (airbase-u* pilots true)
)
(table in-length add
    (forts-u* opmat* 10)
    (forts1 opmat* 5)
    (base-u* opmat* 10)
    (forts1 cnc 5)
    (forts2 cnc 10)
    (forts3 cnc 20)
    (level1-base-u* cnc 10)
    (level2-base-u* cnc 20)
    (level3-base-u* cnc 30)
    (refinery-u* cnc (20 30))
    (forts-u* fuelL 20)
    (forts1 fuelL 10)
    (camp-u* fuelL 20)
    (airbase-u* fuelL 20)
    (airbase-u* fuelA 20)
    (seabase-u* fuelL 20)
    (seabase-u* fuelS 20)
    (forts-u* (bulk cmat) 10)
    (forts1 (bulk cmat) 5)
    (base-u* (bulk cmat vehicles equipment) 20)
    (refinery1 (bulk cmat) 20)
    (refinery2 (bulk cmat) 30)
)
(table out-length add
    (forts-u* opmat* 10)
    (forts1 opmat* 5)
    (base-u* opmat* 10)
    (forts1 cnc 5)
    (forts2 cnc 10)
    (forts3 cnc 20)
    (level1-base-u* cnc 10)
    (level2-base-u* cnc 20)
    (level3-base-u* cnc 30)
    (forts-u* fuelL 20)
    (forts1 fuelL 10)
    (camp-u* fuelL 20)
    (airbase-u* fuelL 20)
    (airbase-u* fuelA 20)
    (seabase-u* fuelL 20)
    (seabase-u* fuelS 20)
    (refinery1 fuel-m* 20)
    (refinery2 fuel-m* 30)
)

; UMAT_LAND_U
(table unit-storage-x add
    (land-combat-u* cnc (8 14 14 12 18 14 30 80))
    (artillery-u* cnc (14 12))
    (field-hq cnc 975)
    (spies cnc 112)
    (engineer-u* cnc (36 26))
    (truck-convoy cnc 12)
    (land-combat-u* fuelL (0 30 36 36 36 0 45 0))
    (artillery-u* fuelL (12 18))
    (field-hq fuelL 30)
    (spies fuelL 0)
    (engineer-u* fuelL 36)
    (truck-convoy fuelL 100)
    (land-combat-u* psup (6 6 6 6 6 6 6 0))
    (artillery-u* psup 6)
    (field-hq psup 3)
    (spies psup 0)
    (engineer-u* psup (0 3))
    (truck-convoy psup 10)
    (land-combat-u* msup (6 12 12 12 18 6 18 0))
    (artillery-u* msup 12)
    (field-hq msup 12)
    (spies msup 0)
    (engineer-u* msup 24)
    (truck-convoy msup 60)
    (engineer-u* bulk (10 10))
    (engineer-u* cmat (10 10))
)
(table base-production add
    (field-hq cnc 195)
)
(table base-consumption add
    (land-combat-u* cnc (2 2 3 3 5 5 10 15))
    (artillery-u* cnc 3)
    (spies cnc 20)
    (engineer-u* cnc (15 10))
    (truck-convoy cnc 1)
    (land-combat-u* psup (2 2 2 2 2 2 2 0))
    (artillery-u* psup 2)
    (field-hq psup 1)
    (spies psup 0)
    (engineer-u* psup (0 1))
    (truck-convoy psup 1)
    (land-combat-u* msup (2 4 4 4 6 2 6 0))
    (artillery-u* msup 4)
    (field-hq msup 4)
    (spies msup 0)
    (engineer-u* msup 8)
    (truck-convoy msup 6)
)
(table consumption-as-occupant add
    (land-u* cnc 50%)   ; Resting or hunkered down units....
    (land-u* msup 50%)
)
(table hp-per-starve add
    (land-u* psup 100.00)
)
(table takes-from-treasury add
    (germinator settlers true)
)
(table in-length add
    (land-combat-u* cnc (5 5 5 5 10 10 20 20))
    (artillery-u* cnc 10)
    (spies cnc 20)
    (engineer-u* cnc 10)
    (truck-convoy cnc 5)
    (land-u* fuelL 20)
    (land-u* psup 10)
    (land-u* msup 10)
    (engineer-u* (bulk cmat) 10)
)
(table out-length add
    (field-hq cnc 20)
)

; UMAT_SEA_U
(table unit-storage-x add
    (boat-u* cnc 10)
    (light-sea-combat-u* cnc 12)
    (heavy-sea-combat-u* cnc (18 320))
    (submarine cnc 56)
    (command-ship cnc 850)
    (carrier-u* cnc (12 28 290))
    (sea-transport-u* cnc (6 16 16))
    (sea-support-u* cnc 8)
    (boat-u* fuelS (30 60))
    (light-sea-combat-u* fuelS 120)
    (heavy-sea-combat-u* fuelS (240 400))
    (submarine fuelS 60)
    (command-ship fuelS 120)
    (carrier-u* fuelS (120 240 400))
    (sea-transport-u* fuelS (180 60 60))
    (sea-support-u* fuelS (360 30))
    (boat-u* psup 10)
    (light-sea-combat-u* psup 10)
    (heavy-sea-combat-u* psup (20 30))
    (submarine psup 10)
    (command-ship psup 10)
    (carrier-u* psup (10 20 40))
    (sea-transport-u* psup (0 10 10))
    (sea-support-u* psup (30 10))
    (boat-u* msup (10 20))
    (light-sea-combat-u* msup 40)
    (heavy-sea-combat-u* msup (60 100))
    (submarine msup 20)
    (command-ship msup 40)
    (carrier-u* msup (40 60 100))
    (sea-transport-u* msup (80 20 20))
    (sea-support-u* msup (120 10))
    (mineship bulk 10)
)
(table base-production add
    (command-ship cnc 170)
    (battleship cnc 64)
    (fleet-carrier cnc 58)
)
(table base-consumption add
    (boat-u* cnc 2)
    (light-sea-combat-u* cnc 3)
    (heavy-sea-combat-u* cnc (5 0))
    (submarine cnc 10)
    (carrier-u* cnc (3 10 0))
    (sea-transport-u* cnc (1 5 5))
    (sea-support-u* cnc 1)
    (boat-u* psup 1)
    (light-sea-combat-u* psup 1)
    (heavy-sea-combat-u* psup (2 3))
    (submarine psup 1)
    (command-ship psup 1)
    (carrier-u* psup (1 2 4))
    (sea-transport-u* psup (0 1 1))
    (sea-support-u* psup 1)
    (boat-u* msup (1 2))
    (light-sea-combat-u* msup 4)
    (heavy-sea-combat-u* msup (6 10))
    (submarine msup 2)
    (command-ship msup 4)
    (carrier-u* msup (4 6 10))
    (sea-transport-u* msup (8 2 2))
    (sea-support-u* msup (4 1))
)
(table consumption-as-occupant add
    (sea-u* cnc 50%)    ; Resting or docked units....
    (sea-u* msup 50%)
)
(table hp-per-starve add
    (sea-u* psup 100.00)
)
(table in-length add
    (boat-u* cnc 10)
    (light-sea-combat-u* cnc 10)
    (heavy-sea-combat-u* cnc (20 0))
    (submarine cnc 20)
    (carrier-u* cnc (10 20 20))
    (sea-transport-u* cnc 10)
    (sea-support-u* cnc 10)
    ; Resupplying must be done at radius 0.
)
(table out-length add
    (command-ship cnc 20)
    (battleship cnc 5)
    (fleet-carrier cnc 5)
)

; UMAT_AIR_U
(table unit-storage-x add
    (fighter-u* cnc 42)
    (bomber-u* cnc 34)
    (spy-planes cnc 60)
    (cargo-planes cnc 30)
    (fighter-u* fuelA (32 128))
    (bomber-u* fuelA (24 24 192))
    (spy-planes fuelA 80)
    (cargo-planes fuelA 160)
    (fighter-u* psup (2 3))
    (bomber-u* psup (2 2 6))
    (spy-planes psup 3)
    (cargo-planes psup 6)
    (fighter-u* msup (8 12))
    (bomber-u* msup (8 8 12))
    (spy-planes msup 6)
    (cargo-planes msup 12)
)
(table base-consumption add
    (fighter-u* cnc 5)
    (bomber-u* cnc 5)
    (spy-planes cnc 10)
    (cargo-planes cnc 5)
    (fighter-u* fuelA (16 32))
    (bomber-u* fuelA (12 12 48))
    (spy-planes fuelA 20)
    (cargo-planes fuelA 40)
    (fighter-u* psup 1)
    (bomber-u* psup (1 1 2))
    (spy-planes psup 1)
    (cargo-planes psup 2)
    (fighter-u* msup 4)
    (bomber-u* msup 4)
    (spy-planes msup 2)
    (cargo-planes msup 4)
)
(table consumption-as-occupant add
    (air-u* cnc 50%)    ; Resting units....
    (air-u* msup 50%)
    (air-u* fuelA 0%)   ; Aircraft don't crash, if already landed.
)
(table hp-per-starve add
    (air-u* fuelA 100.00)
)
(table in-length add
    (air-u* cnc 20)
    ; Resupplying must be done at radius 0.
)

;; Occupancy Allowances and Relative Sizes

; TOCC_GENERAL
(add t* capacity 16)
(add barrier capacity 0)

; UOCC_GENERAL
(table terrain-capacity-x
    ; Default: 0
)
(table unit-size-in-terrain
    ; Default: 1
    (u* t* 1000)
)
(table unit-capacity-x
    ; Default: 0
)
(table occupant-max
    ; Default: -1
    (u* u* 0)
)
(table unit-size-as-occupant
    ; Default: 1
    (u* u* 1000)
)

; UOCC_CITY_U
(table unit-size-in-terrain add
    (city-u* land-t* 16)
    (ruins land-t* 13)
    (town land-t* 13)
)
(add city-u* capacity (1 2 4 6 3 6))
(table occupant-max add
    (ruins land-u* 1)
    (town land-u* 2)
    (city land-u* 4)
    (metropolis land-u* 6)
    (citadel land-u* 3)
    (capitol land-u* 6)
)
(table unit-size-as-occupant add
    (land-u* city-u* 1)
)
(add city-u* ai-peace-garrison (0 0 1 2 1 3))
(add city-u* ai-war-garrison (0 1 2 4 2 6))

; UOCC_FACILITY_U
(table unit-size-in-terrain add
    ((forts1 camp1 airbase1) land-t* 4)
    (seabase1 coast 4)
    ((forts2 camp2 airbase2) land-t* 8)
    (seabase2 coast 8)
    ((forts3 camp3 airbase3) land-t* 13)
    (seabase3 coast 13)
    (refinery1 land-t* 4)
    (refinery2 land-t* 8)
)
(add forts-u* capacity (2 4 6))
(add level1-base-u* capacity 2)
(add level2-base-u* capacity 4)
(add level3-base-u* capacity 6)
(add refinery-u* capacity (1 2))
(table unit-capacity-x add
    (airbase1 (append airborne-land-u* engineers) 1)
    (airbase2 (append airborne-land-u* engineers) 2)
    (airbase3 (append airborne-land-u* engineers) 4)
    (seabase1 (append marine-land-u* engineers) 1)
    (seabase2 (append marine-land-u* engineers) 2)
    (seabase3 (append marine-land-u* engineers) 4)
)
(table occupant-max add
    (forts1 land-u* 2)
    (forts2 land-u* 4)
    (forts3 land-u* 6)
    (camp1 land-u* 2)
    (camp2 land-u* 4)
    (camp3 land-u* 6)
    (airbase1 air-u* 2)
    (airbase2 air-u* 4)
    (airbase3 air-u* 6)
    (seabase1 sea-u* 2)
    (seabase2 sea-u* 4)
    (seabase3 sea-u* 6)
    (refinery-u* engineers (1 2))
)
(table unit-size-as-occupant add
    (land-u* forts-u* 1)
    ((infantry paratroops engineers) camp1 1)
    (land-u* (camp2 camp3) 1)
    ((append engineers light-air-u*) airbase1 1)
    ((append engineers air-u*) (airbase2 airbase3) 1)
    ((append engineers small-sea-u* barges) seabase1 1)
    ((append marines engineers surface-sea-u*) seabase2 1)
    ((append marine-land-u* engineers sea-u*) seabase3 1)
    (engineers refinery-u* 1)
)
(add forts-u* ai-peace-garrison (0 1 1))
(add base-u* ai-peace-garrison 1)
(add refinery-u* ai-peace-garrison (1 0))
(add forts-u* ai-war-garrison (2 4 6))
(add camp-u* ai-war-garrison (1 2 4))
(add airbase-u* ai-war-garrison 0)
(add seabase-u* ai-war-garrison 0)
(add refinery-u* ai-war-garrison 0)

; UOCC_LAND_U
(table unit-size-in-terrain add
    (land-u* land-t* 1)
    (marine-land-u* (coast lake) 1)
)
(add truck-convoy capacity 2)
(table occupant-max add
    (truck-convoy slow-land-u* (1 1 2 1 1 1 1))
)
(table unit-size-as-occupant add
    (slow-land-u* truck-convoy (2 2 1 2 2 2 2))
)
(add truck-convoy ai-peace-garrison 1)
(add truck-convoy ai-war-garrison 0)

; UOCC_SEA_U
(table unit-size-in-terrain add
    (sea-u* water-t* 1)
)
(add submarine capacity 1)
(add carrier-u* capacity (2 4 6))
(add sea-transport-u* capacity (6 2 2))
(table occupant-max add
    (submarine (special-ops spies) 1)
    (escort-carrier carrier-air-u* 2)
    (light-carrier carrier-air-u* 4)
    (fleet-carrier carrier-air-u* 6)
    (barges land-u* 6)
    (troopship land-u* 1)
    (troopship special-ops 2)
    (amphib-ship marines 1)
    (amphib-ship special-ops 2)
)
(table unit-size-as-occupant add
    ((special-ops spies) submarine 1)
    (carrier-air-u* carrier-u* 1)
    (land-u* barges 1)
    (land-u* troopship 2)
    (special-ops troopship 1)
    (marines amphib-ship 2)
    (special-ops amphib-ship 1)
)
(table unit-capacity-x add
    ; Barges move by letting tugs "occupy" them to increase their speed.
    (barges tugboat 1)
)
(add submarine ai-peace-garrison 1)
(add carrier-u* ai-peace-garrison (2 4 6))
(add sea-transport-u* ai-peace-garrison (6 1 1))
(add submarine ai-war-garrison 0)
(add carrier-u* ai-war-garrison 0)
(add sea-transport-u* ai-war-garrison 0)

; UOCC_AIR_U
(table terrain-capacity-x add
    (air-u* t* 2)
)
(table unit-size-in-terrain add
    (air-u* (append land-t* water-t*) 1)
)
(add cargo-planes capacity 2)
(table occupant-max add
    (cargo-planes paratroops 1)
    (cargo-planes special-ops 2)
)
(table unit-size-as-occupant add
    (paratroops cargo-planes 2)
    (special-ops cargo-planes 1)
)
(add cargo-planes ai-peace-garrison 1)
(add cargo-planes ai-war-garrison 0)

; OCCS_MINE_U
; Mines can be laid without impeding friendly forces passing through.
(table terrain-capacity-x add
    (landmines land-t* 16)
    (seamines water-t* 16)
)
(table unit-size-in-terrain add
    (landmines land-t* 4)
    (seamines water-t* 4)
)

;; Zones of Control

; ZOC_GENERAL
(table zoc-range
    ; Default: 0
    (u* u* -1)
)
(table zoc-into-terrain
    ; Default: true
    (u* t* false)
)
(table zoc-from-terrain-effect
    ; Default: 100%
    (u* t* 100%)
)

; ZOC_CITY_U
(table zoc-range add
    (city-u* u* 0)
    (ruins u* -1)
    ; TODO: Make larger cities extend a farther ZOC.
)
(table zoc-into-terrain add
    (city-u* land-t* true)
    (ruins t* false)
)

; ZOC_FACILITY_U
; Facilities do not exert a ZOC; only their occs do.

; ZOC_LAND_U
(table zoc-range add
    (land-combat-u* land-u* 0)
    (land-combat-u* spies -1)
    (aaa air-u* 0)
    ; TODO: Make combat units extend a ZOC out to their attack/fire ranges.
)
(table zoc-into-terrain add
    (land-combat-u* (plains desert swamp road) true)
)

; ZOC_SEA_U
(table zoc-range add
    (sea-combat-u* sea-u* 0)
    (sea-combat-u* submarine -1)
    (destroyer submarine 0)
    (frigate air-u* 0)
    ; TODO: Make combat units extend a ZOC out to their attack/fire ranges.
)
(table zoc-into-terrain add
    (sea-combat-u* water-t* true)
)

; ZOC_AIR_U
(table zoc-range add
    (fighter-u* air-u* 0)
    ; TODO: Make combat units extend a ZOC out to their attack/fire ranges.
)
(table zoc-into-terrain add
    (fighter-u* t* true)
    (fighter-u* barrier false)
)

; ZOC_MINE_U
(table zoc-range add
    (landmines land-u* 0)
    (seamines sea-u* 0)
)
(table zoc-into-terrain add
    (landmines (append land-t* road) true)
    (seamines water-t* true)
)

;; Movement

; MOVE_GENERAL
(table material-to-move
    ; Default: 0
    (u* cnc 1)
)
(table consumption-per-move
    ; Default: 0
    (u* cnc 1)
)
(table occupant-adds-speed
    ; Default: 0%
)
(table occupant-multiplies-speed
    ; Default: 100%
)
(table mp-to-enter-terrain
    ; Default: 1
    (u* t* 1000)
)
(table mp-to-leave-terrain
    ; Default: 0
    (u* t* 1000)
)
(table mp-to-traverse
    ; Default: -1
)
(table mp-to-enter-zoc
    ; Default: -1
)
(table mp-to-leave-zoc
    ; Default: 0
)
(table mp-to-traverse-zoc
    ; Default: 0
    (u* u* 1)
)
(table mp-to-enter-own
    ; Default: -1
)
(table can-enter-independent
    ; Default: false
)
(table acp-to-enter-unit
    ; Default: 1
    (u* u* 1000)
)
(table mp-to-enter-unit
    ; Default: 0
    (u* u* 1000)
)
(table mp-to-leave-unit
    ; Default: 0
)
(table ferry-on-entry
    ; Default: over-border
    (u* u* over-nothing)
)
(table ferry-on-departure
    ; Default: over-border
    (u* u* over-nothing)
)

; MOVE_CITY_U
(add city-u* acp-to-move 1000)
(add city-u* speed 0%)
(add city-u* free-mp 0)

; MOVE_FACILITY_U
(add specialty-facility-u* acp-to-move 1000)
(add specialty-facility-u* speed 0%)
(add specialty-facility-u* free-mp 0)

; MOVE_LAND_U
(add wrecks acp-to-move 1000)
(add wrecks speed 0%)
(add land-combat-u* speed (50% 100% 50% 50% 50% 50% 50% 33%))
(add artillery-u* speed (100% 50%))
(add field-hq speed 100%)
(add spies speed 100%)
(add engineer-u* speed 100%)
(add truck-convoy speed 100%)
(add wrecks free-mp 0)
(table material-to-move add
    (land-combat-u* fuelL (0 2 3 4 3 0 3 0))
    (artillery-u* fuelL 2)
    (field-hq fuelL 2)
    (spies fuelL 0)
    (engineer-u* fuelL 4)
    (truck-convoy fuelL 2)
)
(table consumption-per-move add
    (land-u* cnc 1)
    (land-combat-u* fuelL (0 2 3 4 3 0 3 0))
    (artillery-u* fuelL 2)
    (field-hq fuelL 2)
    (spies fuelL 0)
    (engineer-u* fuelL 4)
    (truck-convoy fuelL 2)
)
(table mp-to-enter-terrain add
    (land-u* (plains desert river) 1)
    (land-u* road 0)
    (footsoldier-u* (swamp forest mountains) 2)
    ((marines special-ops) (coast lake) 2)
    ((marines special-ops) river 0)
    (special-ops glaciers 2)
    (spies land-t* 1)
)
(table mp-to-leave-terrain add
    (land-u* (plains desert road river) 0)
    (footsoldier-u* (swamp forest mountains) 0)
    ((marines special-ops engineers) (coast lake) 0)
    (special-ops glaciers 0)
    (spies land-t* 0)
)
(table mp-to-traverse add
    (land-u* road 1)
)
(table mp-to-enter-zoc add
    (land-combat-u* facility-u* 1)
    (land-combat-u* land-u* 1)
    (land-u* mine-u* 1)
)
(table mp-to-enter-own add
    (land-combat-u* u* 0)
)
(table acp-to-enter-unit add
    (infantry (append city-u* forts-u* camp-u* truck-convoy barges troopship) 2)
    (mechinf (append city-u* forts-u* camp-u* barges troopship) 1)
    (cavalry (append city-u* forts-u* camp-u* barges troopship) 2)
    (armor (append city-u* forts-u* camp-u* truck-convoy barges troopship) 2)
    (marines (append city-u* forts-u* camp-u* seabase-u* sea-transport-u*) 2)
    (paratroops 
        (append city-u* forts-u* camp-u* airbase-u* barges troopship 
            cargo-planes) 2)
    (stormtroops 
        (append city-u* forts-u* camp-u* truck-convoy barges troopship) 2)
    (special-ops 
        (append city-u* forts-u* base-u* truck-convoy submarine 
            sea-transport-u* cargo-planes) 3)
    (artillery (append city-u* forts-u* camp-u* barges troopship) 1)
    (aaa (append city-u* forts-u* camp-u* truck-convoy barges troopship) 2)
    (field-hq (append city-u* forts-u* camp-u* barges troopship) 1)
    (spies (append city-u* forts-u* camp-u* submarine barges troopship) 1)
    (germinator 
        (append city-u* forts-u* camp-u* truck-convoy barges troopship) 1)
    (engineers (append facility-u* truck-convoy barges troopship) 1)
    (truck-convoy (append city-u* forts-u* camp-u* barges troopship) 1)
)
(table mp-to-enter-unit add
    (land-u* city-u* 1)
    (land-u* (append forts-u* camp-u*) 1)
    (marine-land-u* seabase-u* 1)
    (airborne-land-u* airbase-u* 1)
    (engineers facility-u* 1)
    (slow-land-u* truck-convoy 1)
    (land-u* (barges troopship) 1)
    (marine-land-u* amphib-ship 1)
    ((special-ops spies) submarine 1)
    (airborne-land-u* cargo-planes 1)
)
(table mp-to-leave-unit add
    (slow-land-u* truck-convoy 1)
    (land-u* (barges troopship) 1)
    (marine-land-u* amphib-ship 1)
    ((special-ops spies) submarine 1)
    (airborne-land-u* cargo-planes 1)
)
(table ferry-on-entry add
    (u* land-u* over-border)
)
(table ferry-on-departure add
    (seabase-u* engineers over-border)
    (sea-u* land-u* over-border)
)

; MOVE_SEA_U
(add shipwreck acp-to-move 0)
(add shipwreck speed 0%)
(add boat-u* speed 50%)
(add light-sea-combat-u* speed 50%)
(add heavy-sea-combat-u* speed 50%)
(add submarine speed 100%)
(add command-ship speed 100%)
(add carrier-u* speed 100%)
(add sea-transport-u* speed 100%)
(add sea-support-u* speed 100%)
(table occupant-adds-speed add
    (barges tugboat 100%)
)
(table occupant-multiplies-speed add
    (barges tugboat 150%)
)
(add shipwreck free-mp 0)
(table material-to-move add
    (boat-u* fuelS (1 2))
    (light-sea-combat-u* fuelS 4)
    (heavy-sea-combat-u* fuelS (6 10))
    (submarine fuelS 2)
    (command-ship fuelS 4)
    (carrier-u* fuelS (4 6 10))
    (sea-transport-u* fuelS (6 2 2))
    (sea-support-u* fuelS (4 1))
)
(table consumption-per-move add
    (boat-u* fuelS (1 2))
    (light-sea-combat-u* fuelS 4)
    (heavy-sea-combat-u* fuelS (6 10))
    (submarine fuelS 2)
    (command-ship fuelS 4)
    (carrier-u* fuelS (4 6 10))
    (sea-transport-u* fuelS (6 2 2))
    (sea-support-u* fuelS (4 1))
)
(table mp-to-enter-terrain add
    (sea-u* water-t* 1)
)
(table mp-to-leave-terrain add
    (sea-u* water-t* 0)
)
(table mp-to-traverse add
    (small-sea-u* river 1)
)
(table mp-to-enter-zoc add
    (sea-combat-u* facility-u* 1)
    (sea-combat-u* marine-land-u* 0)
    (sea-combat-u* sea-u* 1)
    (submarine sea-u* 0)
    (sea-u* mine-u* 1)
)
(table mp-to-enter-own add
    (sea-combat-u* u* 0)
)
(table acp-to-enter-unit add
    (boat-u* seabase-u* 2)
    (light-sea-combat-u* seabase-u* 2)
    (heavy-sea-combat-u* seabase-u* 2)
    (submarine seabase-u* 1)
    (command-ship seabase-u* 1)
    (carrier-u* seabase-u* 1)
    (barges seabase-u* 1)
    (troopship seabase-u* 1)
    (amphib-ship seabase-u* 2)
    (sea-support-u* seabase-u* 1)
    (tugboat barges 1)
)
(table mp-to-enter-unit add
    (sea-u* seabase-u* 1)
    (tugboat barges 1)
)
(table ferry-on-entry add
    (facility-u* sea-u* over-own)
)

; MOVE_AIR_U
(add air-u* speed 100%)
(table material-to-move add
    (fighter-u* fuelA (1 2))
    (bomber-u* fuelA (1 1 4))
    (spy-planes fuelA 1)
    (cargo-planes fuelA 4)
)
(table consumption-per-move add
    (fighter-u* fuelA (1 2))
    (bomber-u* fuelA (1 1 4))
    (spy-planes fuelA 1)
    (cargo-planes fuelA 4)
)
(table mp-to-enter-terrain add
    (air-u* (append land-t* water-t*) 1)
    (air-u* (road river) 0)
)
(table mp-to-leave-terrain add
    (air-u* (append land-t* water-t* road river) 0)
)
(table mp-to-enter-zoc add
    (air-u* u* 1)
)
(table mp-to-enter-own add
    (air-u* u* 0)
)
(table acp-to-enter-unit add
    (air-u* airbase-u* 1)
    (carrier-air-u* carrier-u* 1)
)
(table mp-to-enter-unit add
    (air-u* airbase-u* 1)
    (carrier-air-u* carrier-u* 1)
)
(table mp-to-leave-unit add
    (air-u* airbase-u* 1)
    (carrier-air-u* carrier-u* 1)
)

; MOVE_MINE_U
(add mine-u* acp-to-move 0)
(add mine-u* speed 0%)
(add mine-u* free-mp 0)

;; Combat

; CMBT_GENERAL
(table material-to-fire
    ; Default: 0
    (u* cnc 1)
)
(table consumption-per-fire
    ; Default: 0
    (u* cnc 1)
)
(table acp-to-be-fired-on
    ; Default: 1
    (u* u* 0)
)
(table acp-to-attack
    ; Default: 1
    (u* u* 0)
)
(table material-to-attack
    ; Default: 0
    (u* cnc 1)
)
(table consumption-per-attack
    ; Default: 0
    (u* cnc 1)
)
(table hit-by
    ; Default: 0
    (u* cnc 1)
)
(table counterattack
    ; Default: 100%
    (u* u* 0%)
)
(table acp-to-defend
    ; Default: 1
    (u* u* 0)
)
(table occupant-combat
    ; Default: 100%
    (u* u* 0%)
)
(table hit-chance
    ; Default: 0%
)
(table fire-hit-chance
    ; Default: -1
)
(table hit-at-max-range-effect
    ; Default: 100%
)
(table protection
    ; Vulnerability, actually.
    ; Default: 100%
)
(table cellwide-protection-against
    ; Default: 100%
)
(table attack-terrain-effect
    ; Default: 100%
)
(table fire-attack-terrain-effect
    ; Default: -1
)
(table defend-terrain-effect
    ; Default: 100%
)
(table fire-defend-terrain-effect
    ; Default: -1
)
(table damage
    ; Default: 0
)
(table hp-min
    ; Default: 0
)

; CMBT_CITY_U
(table protection add
    (city-u* land-u* 75%)
)
(table hp-min add
    (u* ruins 20)
    (engineers ruins 0)
)

; CMBT_FACILITY_U
(table occupant-combat add
    ; Forts are designed to provide combat advantage.
    (land-u* forts1 150%) (land-u* forts2 250%) (land-u* forts3 350%)
    ; Grounded aircraft are useless.
    ; Moored ships are not very effective.
    (sea-u* seabase-u* 25%)
    ; Penned submarines are useless.
    (submarine seabase-u* 0%)
    ; Very dangerous to fight around a refinery.
    (land-u* refinery-u* 25%)
)
(table protection add
    (forts1 land-u* 50%) (forts2 land-u* 25%) (forts3 land-u* 5%)
    (camp1 land-u* 75%) ((camp2 camp3) land-u* 50%)
    (airbase1 air-u* 500%) (airbase2 air-u* 100%) (airbase3 air-u* 25%)
    (seabase1 sea-u* 250%) (seabase2 sea-u* 100%) (seabase3 sea-u* 50%)
    ; Pens provide extra protection for the Unterseebooten.
    (seabase-u* submarine 5%)
    ; Very dangerous to fight around a refinery.
    (refinery-u* land-u* 250%) 
)

; CMBT_LAND_U
(add land-combat-u* acp-to-fire (0 1 1 1 1 0 1 0))
(add artillery-u* acp-to-fire 1)
(table acp-to-be-fired-on add
    (wrecks u* 0)
    (land-combat-u* u* (2 1 2 2 2 2 2 3))
    (artillery-u* u* (1 2))
    ((field-hq spies) u* 1)
    (engineer-u* u* 1)
    (truck-convoy u* 1)
)
(add land-combat-u* range (0 1 1 2 1 0 2 0))
(add artillery-u* range (4 2))
(add artillery-u* range-min (1 0))
(add artillery hit-falloff-range 2)
(add land-combat-u* fire-angle-max (0% 0% 50% 50% 0% 0% 50% 0%))
(add artillery-u* fire-angle-max 100%)
(table acp-to-attack add
    (land-combat-u* (append facility-u* land-u*) (4 2 3 4 3 4 4 3))
    ; Artillery can only fire, not attack.
    ; Spies can sabotage some facilities.
    (spies (append indu-city-u* govt-city-u* refinery-u*) 3)
    ; Field HQ's, Truck Convoys, and engineer types are helpless.
    ; But Engineers can remove Ruins, Wrecks, Landmines by attacking them.
    (engineers (ruins wrecks landmines) 3)
)
(table acp-to-defend add
    (land-combat-u* u* (2 1 2 2 2 2 2 3))
    (artillery-u* u* (1 2))
    ((field-hq spies) u* 1)
    (engineer-u* u* 1)
    (truck-convoy u* 1)
)
(table counterattack add
    (land-combat-u* land-u* 100%)
    (aaa air-u* 100%)
)
(table occupant-combat add
    ; Land units have trouble fighting from troop transports.
    ; However, Marines can fight from amphib assault ships.
    (marines amphib-ship 75%)
    ; Artillery units can operate fairly well from flat barges.
    (artillery-u* barges 95%)
)
(table hit-chance add
    (land-combat-u* facility-u* BA_ALWAYS)
    (std-land-combat-u* land-u* BA_LIKELY)
    (special-land-combat-u* land-u*
        (BA_VERY_LIKELY BA_VERY_LIKELY BA_ALWAYS BA_ALWAYS))
    (land-combat-u* wrecks BA_ALWAYS)
    (spies facility-u* BA_ALWAYS)
    (engineers (ruins wrecks landmines) BA_ALWAYS)
)
(table fire-hit-chance add
    (land-u* facility-u* BA_ALWAYS)
    (std-land-combat-u* land-u* 
        (BA_NEVER BA_VERY_UNLIKELY BA_UNLIKELY BA_UNLIKELY))
    (special-land-combat-u* land-u*
        (BA_LIKELY BA_NEVER BA_VERY_LIKELY BA_NEVER))
    (artillery-u* land-u* (BA_VERY_LIKELY BA_LIKELY))
    (aaa heavy-air-u* BA_VERY_LIKELY)
    (aaa light-air-u* BA_5050)
    (aaa spy-planes BA_NEVER)
)
(table hit-at-max-range-effect add
    ; Immobile targets are fairly easy to hit, even at distance.
    (artillery facility-u* 80%)
    ; Moving targets are harder to hit.
    (artillery land-u* 33%)
)
(table protection add
    ; Units are fish in a barrel when being transported by a Truck Convoy.
    (truck-convoy land-u* 500%)
)
(table cellwide-protection-against add
    ; HACK: Prevent occupied Ruins from being hit by Engineers.
    (land-combat-u* engineers 0%)
    ; Half the chances of any air attack due to heavy ground fire.
    (aaa air-u* 50%)
)
(table defend-terrain-effect add
    (land-u* swamp 150%)
    (land-u* (forest mountains) 50%)
    (land-u* road 300%)
    (footsoldier-u* (forest mountains) 25%)
    (special-ops (forest mountains glaciers) 5%)
)
(table damage add
    ((infantry paratroops) facility-u* 3)
    ((infantry paratroops) land-u* 1d3+1)
    (mechinf facility-u* 6)
    (mechinf land-u* 1d4+3)
    ((cavalry marines) facility-u* 11)
    ((cavalry marines) land-u* 1d8+4)
    (armor facility-u* 18)
    (armor land-u* 1d12+7)
    (stormtroops facility-u* 1d4)
    (stormtroops land-u* 1d7+6)
    (special-ops facility-u* 1d3)
    (special-ops land-u* 2d2+2)
    (spies indu-city-u* (3d4 5d6 7d8))
    (spies govt-city-u* (3d4 5d6))
    (spies refinery-u* (1d4 2d4))
    (engineers ruins 10)
    (engineers wrecks 4)
    (engineers landmines 2)
)
(table fire-damage add
    (artillery facility-u* 16)
    (artillery land-u* 1d12+9)
    (aaa facility-u* 11)
    (aaa land-u* 1d8+4)
    (aaa air-u* 1d2+1)
)
; Wrecks can be removed by any attacking unit, not just engineers.

; CMBT_SEA_U
(add sea-combat-u* acp-to-fire 2)
(add amphib-ship acp-to-fire 2)
(table acp-to-be-fired-on add
    (shipwreck u* 0)
    (boat-u* u* 2)
    (sea-combat-u* u* 2)
    (submarine u* 0)
    (amphib-ship u* 2)
)
(add heavy-sea-combat-u* range (2 4))
(add heavy-sea-combat-u* hit-falloff-range 2)
(add amphib-ship fire-angle-max 0%)
(add sea-combat-u* fire-angle-max 50%)
(table acp-to-attack add
    (torp-boat surface-sea-u* 4)
    (torp-boat small-sea-u* 0)
    (mineship seamines 6)
    (destroyer submarine 4)
    (light-sea-combat-u* small-sea-u* 4)
    (submarine surface-sea-u* 2)
    (submarine small-sea-u* 0)
    (tugboat shipwreck 1)
)
(table acp-to-defend add
    (shipwreck u* 0)
    (shipwreck tugboat 1)
    (boat-u* u* 2)
    (sea-combat-u* u* 2)
    (amphib-ship u* 2)
)
(table counterattack add
    (sea-combat-u* sea-u* 100%)
    (frigate air-u* 100%)
)
(table hit-chance add
    (torp-boat light-sea-combat-u* BA_UNLIKELY)
    (torp-boat heavy-sea-combat-u* (BA_5050 BA_LIKELY))
    (torp-boat command-ship BA_UNLIKELY)
    (torp-boat carrier-u* (BA_UNLIKELY BA_5050 BA_LIKELY))
    (torp-boat sea-transport-u* (BA_ALWAYS BA_5050 BA_UNLIKELY))
    (torp-boat sea-support-u* (BA_5050 BA_NEVER))
    (mineship seamines BA_ALWAYS)
    (light-sea-combat-u* small-sea-u* BA_5050)
    (destroyer submarine BA_5050)
    (submarine light-sea-combat-u* BA_5050)
    (submarine heavy-sea-combat-u* (BA_LIKELY BA_VERY_LIKELY))
    (submarine submarine BA_LIKELY)
    (submarine command-ship BA_5050) 
    (submarine carrier-u* (BA_5050 BA_LIKELY BA_VERY_LIKELY))
    (submarine sea-transport-u* (BA_ALWAYS BA_LIKELY BA_5050))
    (submarine sea-support-u* (BA_LIKELY BA_NEVER))
    (tugboat shipwreck BA_ALWAYS)
)
(table fire-hit-chance add
    (sea-combat-u* facility-u* BA_ALWAYS)
    (sea-combat-u* land-u* BA_UNLIKELY)
    (sea-combat-u* midsize-sea-u* BA_5050)
    (sea-combat-u* large-sea-u* BA_LIKELY)
    (sea-combat-u* xlarge-sea-u* BA_VERY_LIKELY)
    (frigate heavy-air-u* BA_VERY_LIKELY)
    (frigate light-air-u* BA_5050)
    (frigate spy-planes BA_NEVER)
    (amphib-ship facility-u* BA_ALWAYS)
    (amphib-ship land-u* BA_5050)
)
(table hit-at-max-range-effect add
    ; Immobile targets are fairly easy to hit, even at distance.
    (battleship facility-u* 80%)
    ; Moving targets are harder to hit.
    (battleship land-u* 20%)
    (battleship sea-u* 33%)
)
(table protection add
    ; Units being transported are generally quite helpless.
    (sea-transport-u* land-u* 500%)
    ((escort-carrier light-carrier) air-u* 500%)
    ; Fleet carriers are armored and thus offer more protection.
    (fleet-carrier air-u* 150%)
)
(table cellwide-protection-against add
    ; Half the chances of any sub attack due to heavy depth-charging.
    (destroyer submarine 50%)
    ; Half the chances of any air attack due to heavy flak.
    (frigate air-u* 50%)
)
(table damage add
    (mineship seamines 2)
    (torp-boat surface-sea-u* 3d7+10)
    (light-sea-combat-u* small-sea-u* 1d4+1)
    (destroyer submarine 1d5+4)
    (submarine surface-sea-u* 3d7+10)
    (tugboat shipwreck 4)
)
(table fire-damage add
    (light-sea-combat-u* facility-u* 4)
    (light-sea-combat-u* land-u* 1d2+1)
    (light-sea-combat-u* surface-sea-u* 1d4+1)
    (frigate air-u* 1d2+1)
    (cruiser facility-u* 8)
    (cruiser land-u* 1d2+4)
    (cruiser surface-sea-u* 1d5+4)
    (battleship facility-u* 14)
    (battleship land-u* 1d2+7)
    (battleship surface-sea-u* 1d8+7)
    (amphib-ship facility-u* 3)
    (amphib-ship land-u* 1d3+1)
)
(table hp-min add
    (shipwreck u* 4)
    (shipwreck tugboat 0)
)

; CMBT_AIR_U
(add air-u* acp-to-fire 0)
(table acp-to-be-fired-on add
    (air-u* u* 1)
)
(table acp-to-attack add
    (fighters land-u* 4)
    (fighter-u* air-u* 4)
    (bombers (append facility-u* land-u* sea-u*) 4)
    (dive-bombers (append facility-u* land-u* sea-u*) 4)
    (torp-bombers sea-u* 4)
)
(table acp-to-defend add
    (air-u* u* 1)
)
(table counterattack add
    (fighter-u* u* 100%)
)
(table hit-chance add
    (fighters land-u* BA_LIKELY)
    (fighters footsoldier-u* BA_5050)
    (fighter-u* fighters BA_5050)
    (fighter-u* escort-fighters BA_LIKELY)
    (fighter-u* bombers BA_VERY_LIKELY)
    (fighter-u* (dive-bombers torp-bombers) BA_LIKELY)
    (fighter-u* spy-planes BA_UNLIKELY)
    (fighter-u* cargo-planes BA_ALWAYS)
    (bombers facility-u* BA_5050)
    (bombers land-u* BA_VERY_UNLIKELY)
    (bombers footsoldier-u* BA_NEVER)
    (bombers surface-sea-u* BA_VERY_UNLIKELY)
    (bombers small-sea-u* BA_NEVER)
    (dive-bombers facility-u* BA_VERY_LIKELY)
    (dive-bombers land-u* BA_5050)
    (dive-bombers footsoldier-u* BA_UNLIKELY)
    (dive-bombers surface-sea-u* BA_5050)
    (dive-bombers small-sea-u* BA_VERY_UNLIKELY)
    (dive-bombers midsize-sea-u* BA_UNLIKELY)
    (torp-bombers small-sea-u* BA_UNLIKELY)
    (torp-bombers midsize-sea-u* BA_5050)
    (torp-bombers large-sea-u* BA_LIKELY)
    (torp-bombers xlarge-sea-u* BA_VERY_LIKELY)
    (torp-bombers submarine BA_VERY_UNLIKELY)
)
(table protection add
    ; Units being transported are generally quite helpless.
    (cargo-planes land-u* 500%)
)
(table cellwide-protection-against add
    ; Quarter the effectiveness of aerial attackers when fighters defending.
    (fighter-u* air-u* 25%)
)
(table damage add
    (fighters land-u* 1d2+1)
    (fighter-u* air-u* 1d3+4)
    (bombers facility-u* 5d6+10)
    (bombers (append land-u* sea-u*) 6d6+5)
    (dive-bombers facility-u* 2d6+10)
    (dive-bombers (append land-u* sea-u*) 3d6+5)
    (torp-bombers sea-u* 3d6+5)
)

; CMBT_MINE_U
(table hp-min add
    (landmines u* 6)
    (landmines engineers 0)
    (seamines u* 6)
    (seamines mineship 0)
)

; PCBT_GENERAL
(table acp-for-retreat
    ; Default: 0
)
(table retreat-chance
    ; Default: 0%
)
(table acp-to-capture
    ; Default: 0
)
(table bridge
    ; Default: false
)
(table capture-chance
    ; Default: 0%
)
(table independent-capture-chance
    ; Default: 0%
)
(table countercapture
    ; Default: 0%
)
(table see-others-if-captured
    ; Default: 0%
)
(table scuttle-chance
    ; Default: 0%
    ; Make sure that the enemy cannot use mobile captured units.
    (land-u* u* 100%)
    (sea-u* u* 100%)
    (air-u* u* 100%)
)
(table occupant-escape-chance
    ; Default: 0%
)
(table hp-to-garrison
    ; Default: 0
)

; PCBT_CITY_U
(add city-u* see-terrain-if-captured
    (BA_NEVER BA_VERY_UNLIKELY BA_UNLIKELY BA_LIKELY BA_VERY_LIKELY BA_ALWAYS))
(table see-others-if-captured add
    (town indu-city-u* (BA_VERY_UNLIKELY BA_5050 BA_VERY_LIKELY))
    (town govt-city-u* (BA_LIKELY BA_ALWAYS))
    (town level1-base-u* BA_VERY_UNLIKELY)
    (town level2-base-u* BA_UNLIKELY)
    (town level3-base-u* BA_5050)
    (town refinery-u* (BA_UNLIKELY BA_VERY_LIKELY))
    (city indu-city-u* (BA_UNLIKELY BA_ALWAYS BA_ALWAYS))
    (city govt-city-u* BA_ALWAYS)
    (city level1-base-u* BA_UNLIKELY)
    (city level2-base-u* BA_5050)
    (city level3-base-u* BA_LIKELY)
    (city refinery-u* (BA_LIKELY BA_ALWAYS))
    (metropolis ruins BA_5050)
    (metropolis indu-city-u* (BA_LIKELY BA_ALWAYS BA_ALWAYS))
    (metropolis govt-city-u* BA_ALWAYS)
    (metropolis level1-base-u* BA_LIKELY)
    (metropolis level2-base-u* BA_ALWAYS)
    (metropolis level3-base-u* BA_ALWAYS)
    (metropolis refinery-u* BA_ALWAYS)
    (citadel ruins BA_LIKELY)
    (citadel indu-city-u* (BA_VERY_LIKELY BA_ALWAYS BA_ALWAYS))
    (citadel govt-city-u* BA_ALWAYS)
    (citadel forts-u* (BA_UNLIKELY BA_VERY_LIKELY BA_ALWAYS))
    (citadel base-u* BA_ALWAYS)
    (citadel refinery-u* BA_ALWAYS)
    (citadel mobile-cnc-u* BA_5050)
    (capitol facility-u* BA_ALWAYS)
    (capitol mobile-cnc-u* BA_VERY_LIKELY)
)

; PCBT_FACILITY_U
(add forts-u* see-terrain-if-captured (BA_NEVER BA_UNLIKELY BA_LIKELY))
(add camp-u* see-terrain-if-captured (BA_NEVER BA_UNLIKELY BA_VERY_LIKELY))
(add airbase-u* see-terrain-if-captured (BA_NEVER BA_UNLIKELY BA_VERY_LIKELY))
(add seabase-u* see-terrain-if-captured (BA_NEVER BA_UNLIKELY BA_VERY_LIKELY))
(add refinery-u* see-terrain-if-captured (BA_NEVER BA_UNLIKELY))
(table see-others-if-captured add
    (forts1 govt-city-u* (BA_5050 BA_ALWAYS))
    (forts2 govt-city-u* (BA_LIKELY BA_ALWAYS))
    (forts2 forts-u* (BA_UNLIKELY BA_5050 BA_LIKELY))
    (forts2 level2-base-u* BA_UNLIKELY)
    (forts2 level3-base-u* BA_LIKELY)
    (forts2 landmines BA_UNLIKELY)
    (forts3 govt-city-u* BA_ALWAYS)
    (forts3 forts-u* (BA_UNLIKELY BA_LIKELY BA_VERY_LIKELY))
    (forts3 level2-base-u* BA_LIKELY)
    (forts3 level3-base-u* BA_ALWAYS)
    (forts3 landmines BA_5050)
    (camp1 govt-city-u* (BA_5050 BA_ALWAYS))
    (camp1 camp-u* (BA_UNLIKELY BA_VERY_LIKELY BA_ALWAYS))
    (camp1 land-u* BA_VERY_UNLIKELY)
    (camp2 govt-city-u* BA_ALWAYS)
    (camp2 forts-u* (BA_UNLIKELY BA_ALWAYS BA_ALWAYS))
    (camp2 camp-u* (BA_UNLIKELY BA_ALWAYS BA_ALWAYS))
    (camp2 land-u* BA_UNLIKELY)
    (camp2 landmines BA_UNLIKELY)
    (camp3 govt-city-u* BA_ALWAYS)
    (camp3 forts-u* BA_ALWAYS)
    (camp3 camp-u* BA_ALWAYS)
    (camp3 land-u* BA_5050)
    (camp3 landmines BA_5050)
    (airbase1 govt-city-u* (BA_5050 BA_ALWAYS))
    (airbase1 airbase-u* (BA_UNLIKELY BA_VERY_LIKELY BA_ALWAYS))
    (airbase1 air-u* BA_VERY_UNLIKELY)
    (airbase2 govt-city-u* BA_ALWAYS)
    (airbase2 airbase-u* (BA_UNLIKELY BA_ALWAYS BA_ALWAYS))
    (airbase2 air-u* BA_UNLIKELY)
    (airbase3 govt-city-u* BA_ALWAYS)
    (airbase3 airbase-u* BA_ALWAYS)
    (airbase3 air-u* BA_5050)
    (seabase1 govt-city-u* (BA_5050 BA_ALWAYS))
    (seabase1 seabase-u* (BA_UNLIKELY BA_VERY_LIKELY BA_ALWAYS))
    (seabase1 sea-u* BA_VERY_UNLIKELY)
    (seabase2 govt-city-u* BA_ALWAYS)
    (seabase2 seabase-u* (BA_UNLIKELY BA_ALWAYS BA_ALWAYS))
    (seabase2 sea-u* BA_UNLIKELY)
    (seabase2 seamines BA_UNLIKELY)
    (seabase3 govt-city-u* BA_ALWAYS)
    (seabase3 seabase-u* BA_ALWAYS)
    (seabase3 sea-u* BA_5050)
    (seabase3 seamines BA_5050)
    (refinery1 refinery-u* (BA_5050 BA_ALWAYS))
    (refinery2 refinery-u* BA_ALWAYS)
)
(table scuttle-chance add
    (refinery1 land-u* BA_5050) (refinery2 land-u* BA_UNLIKELY)
)

; PCBT_LAND_U
(table retreat-chance add
    ; Hackish. Used to _force_ weaker units to give up positions.
    (land-combat-u* land-non-combat-u* BA_ALWAYS)
    ((infantry paratroops) footsoldier-u* BA_UNLIKELY)
    ((infantry paratroops) light-land-combat-u* BA_VERY_UNLIKELY)
    ((infantry paratroops) heavy-land-combat-u* BA_NEVER)
    ((mechinf special-ops) footsoldier-u* BA_5050)
    ((mechinf special-ops) light-land-combat-u* BA_UNLIKELY)
    ((mechinf special-ops) heavy-land-combat-u* BA_VERY_UNLIKELY)
    ((cavalry marines) footsoldier-u* BA_LIKELY)
    ((cavalry marines) light-land-combat-u* BA_5050)
    ((cavalry marines) heavy-land-combat-u* BA_UNLIKELY)
    (heavy-land-combat-u* footsoldier-u* BA_VERY_LIKELY)
    (heavy-land-combat-u* light-land-combat-u* BA_LIKELY)
    (heavy-land-combat-u* heavy-land-combat-u* BA_5050)
    (artillery-u* land-non-combat-u* BA_ALWAYS)
    (artillery footsoldier-u* BA_LIKELY)
    (artillery light-land-combat-u* BA_5050)
    (artillery heavy-land-combat-u* BA_UNLIKELY)
    (aaa footsoldier-u* BA_5050)
    (aaa light-land-combat-u* BA_UNLIKELY)
    (aaa heavy-land-combat-u* BA_VERY_UNLIKELY)
    ; TODO: Allow air units to force land unit retreats?
)
(table acp-to-capture add
    (infantry facility-u* 4)
    (mechinf facility-u* 5)
    (cavalry facility-u* 8)
    (armor facility-u* 6)
    (marines facility-u* 8)
    (paratroops facility-u* 4)
    (stormtroops facility-u* 6)
    (special-ops facility-u* 3)
)
(table bridge add
    (facility-u* land-u* true)
)
(table capture-chance add
    ; City units are considered to have paramilitary defenders.
    (land-combat-u* (ruins town) BA_ALWAYS)
    ((infantry paratroops) city BA_LIKELY)
    ((infantry paratroops) metropolis BA_VERY_UNLIKELY)
    ((infantry paratroops) citadel BA_VERY_UNLIKELY)
    ((infantry paratroops) capitol BA_NEVER)
    ((mechinf special-ops) city BA_LIKELY)
    ((mechinf special-ops) metropolis BA_VERY_UNLIKELY)
    ((mechinf special-ops) citadel BA_UNLIKELY)
    ((mechinf special-ops) capitol BA_NEVER)
    ((cavalry marines armor) city BA_VERY_LIKELY)
    ((cavalry marines armor) metropolis BA_UNLIKELY)
    ((cavalry marines armor) citadel BA_5050)
    ((cavalry marines armor) capitol BA_VERY_UNLIKELY)
    (stormtroops city BA_ALWAYS)
    (stormtroops metropolis BA_LIKELY)
    (stormtroops citadel BA_VERY_LIKELY)
    (stormtroops capitol BA_5050)
    ; Facilities are only directly defended by land combat units.
    ; They do not have any implicit defense.
    (land-combat-u* specialty-facility-u* BA_ALWAYS)
)
(table independent-capture-chance add
    ((infantry mechinf paratroops special-ops) city BA_VERY_LIKELY)
    ((infantry mechinf paratroops special-ops) metropolis BA_UNLIKELY)
    ((cavalry marines armor) city BA_ALWAYS)
    ((cavalry marines armor) metropolis BA_5050)
    (stormtroops city BA_ALWAYS)
    (stormtroops metropolis BA_VERY_LIKELY)
)
(table occupant-escape-chance add
    ; TEMPORARY HACK: Do this until Xconq has an 'occupant-capture-effect' 
    ;  table, which would allow captures to be prevented as long as certain 
    ;  types of defender are present.
    (land-u* facility-u* BA_ALWAYS)
    ; Air and sea units are considered destroyed if their transport is 
    ;  captured.
)
; TODO: Handle 'hp-to-garrison'.

; PCBT_SEA_U
(table retreat-chance add
    (destroyer submarine BA_5050)
)

; PCBT_AIR_U
(table retreat-chance add
    (aaa air-u* BA_5050)
    (frigate air-u* BA_5050)
)

; SCBT_GENERAL
(table detonation-unit-range
    ; Default: 0
)
(table detonation-damage-at
    ; Default: 0
)
(table detonation-damage-adjacent
    ; Default: 0
)
; Damage effect extrapolates from detonation-damage-adjacent
(table detonate-on-hit
    ; Default: 0
)
(table detonate-on-approach-range
    ; Default: -1
)

; SCBT_CITY_U
; No special combat for cities.

; SCBT_FACILITY_U
(table detonation-unit-range add
    (refinery2 u* 1)
)
; TODO: Add detonation-accident-chance to a variant.
(table detonate-on-hit add
    (refinery1 u* BA_LIKELY)
    (refinery2 u* BA_VERY_LIKELY)
)
(table detonate-on-capture add
    (refinery1 u* BA_UNLIKELY)
    (refinery2 u* BA_LIKELY)
)
(add refinery-u* detonate-on-death BA_LIKELY)
(add refinery-u* hp-per-detonation (2 6))
(table detonation-damage-at add
    (refinery1 u* 1d5+2)
    (refinery2 u* 1d5+6)
    (refinery-u* air-u* 0)
)
(table detonation-damage-adjacent add
    (refinery2 u* 1d2)
    (refinery2 air-u* 0)
)

; SCBT_LAND_U
; No special combat for land units.

; SCBT_SEA_U
(add boat-u* acp-to-detonate 2)
(add boat-u* hp-per-detonation 10000)
(add supply-ship hp-per-detonation 10000)
(table detonate-on-hit add
    (supply-ship u* BA_5050)
)
(table detonation-damage-at add
    (torp-boat surface-sea-u* 2d7+20)
    (mineship surface-sea-u* 3d7+30)
    (supply-ship surface-sea-u* 1d5+8)
)

; SCBT_AIR_U
(add (append bomber-u* cargo-planes) acp-to-detonate 4)
(add (append bomber-u* cargo-planes) hp-per-detonation 10000)
(table detonation-damage-at add
    (bombers facility-u* 5d6+10)
    (bombers (append land-u* sea-u*) 6d6+5)
    ((dive-bombers torp-bombers) facility-u* 1d6+20)
    ((dive-bombers torp-bombers) (append land-u* surface-sea-u*) 1d6+10)
    ((bombers cargo-planes) facility-u* 3d6+20)
    ((bombers cargo-planes) (append land-u* surface-sea-u*) 3d6+10)
)

; SCBT_MINE_U
(add mine-u* hp-per-detonation 1)
(table detonate-on-approach-range add
    (landmines land-u* 0)
    (seamines sea-u* 0)
)
(table detonation-damage-at add
    (landmines land-u* 1d3+2)
    (landmines engineers 0)
    (seamines sea-u* 1d9+10)
    (seamines mineship 0)
)

;; Surrenders

; PSUR_GENERAL
(table people-surrender-chance
    ; Default: 0%
)

; PSUR_CITY_U
(table people-surrender-chance add
    (city-u* land-t* BA_ALWAYS)
    (ruins land-t* BA_NEVER)
)

; PSUR_FACILITY_U
(table people-surrender-chance add
    (specialty-facility-u* (append land-t* coast) BA_ALWAYS)
    (refinery-u* land-t* BA_NEVER)
)

; PSUR_LAND_U
(table people-surrender-chance add
    (marines coast BA_ALWAYS)
    (marines lake BA_ALWAYS)
    (std-land-combat-u* plains 
        (BA_VERY_LIKELY BA_VERY_LIKELY BA_ALWAYS BA_ALWAYS))
    (special-land-combat-u* plains BA_ALWAYS)
    (std-land-combat-u* desert
        (BA_VERY_LIKELY BA_VERY_LIKELY BA_ALWAYS BA_ALWAYS))
    (special-land-combat-u* desert BA_ALWAYS)
    (std-land-combat-u* swamp (BA_5050 BA_NEVER BA_NEVER BA_NEVER))
    (special-land-combat-u* swamp (BA_LIKELY BA_LIKELY BA_NEVER BA_LIKELY))
    (std-land-combat-u* forest (BA_5050 BA_NEVER BA_NEVER BA_NEVER))
    (special-land-combat-u* forest (BA_NEVER BA_LIKELY BA_NEVER BA_LIKELY))
    (std-land-combat-u* mountains (BA_UNLIKELY BA_NEVER BA_NEVER BA_NEVER))
    (special-land-combat-u* mountains (BA_NEVER BA_5050 BA_NEVER BA_5050))
)

; PSUR_SEA_U
; No surrenders to sea units.

; PSUR_AIR_U
; No surrenders to air untis.

; PSUR_MINE_U
; No surrenders to mines.

;; Creation, Building, and Repair

#|
    Land Units:
    equipment = max(recruits,vehicles)
    psup = recruits
    msup = equipment + vehicles
|#

; CBR_GENERAL
(table acp-to-create
    ; Default: 0
)
(table acp-to-build
    ; Default: 0
)
(table acp-to-repair
    ; Default: 0
)
(table material-to-create
    ; Default: 0
)
(table consumption-on-creation
    ; Default: 0
)
(table supply-on-creation
    ; Default: 0
)
(table material-to-build
    ; Default: 0
)
(table consumption-per-build
    ; Default: 0
)
(table supply-on-completion
    ; Default: 0
)
(table material-to-repair
    ; Default: 0.00
)
(table consumption-per-repair
    ; Default: 0.00
)
(table hp-to-repair
    ; Default: 1
)
(table create-range
    ; Default: 0
)
(table build-range
    ; Default: 0
)
#|
(table repair-range
    ; Default: 0
)
|#
(table auto-repair-range
    ; Default: 0
)
(table cp-on-creation
    ; Default: 1
    (u* u* 0)
)
(table cp-per-build
    ; Default: 1
    (u* u* 0)
)
(table hp-per-repair
    ; Default: 0.00
)
(table auto-repair
    ; Default: 0.00
)

; CBR_CITY_U
(table acp-to-create add
    (germinator (town citadel) 3)
)
(table acp-to-build add
    (germinator (town citadel) 3)
)
; No materials are consumed upon creation.
(table create-range add
    (germinator city-u* 1)
)
(table build-range add
    (germinator city-u* 1)
)
(add city-u* cp (0 40 0 0 80 0))
(add city-u* hp-max (20 120 720 4320 240 4320))
(add city-u* hp-recovery (0.00 3.50 9.50 27.50 4.75 30.75)) 
(table cp-on-creation add
    (germinator city-u* 1)
)
(table cp-per-build add
    (germinator city-u* 1)
)
(add (town citadel) cp-to-self-build (20 40))
(add (town citadel) cp-per-self-build 1)

; CBR_FACILITY_U
(table acp-to-create add
    (city-u* (forts1 camp1 airbase1 seabase1 refinery1) 1)
    (engineers (forts1 camp1 airbase1 seabase1 refinery1) 3)
)
(table acp-to-build add
    (city-u* (forts1 camp1 airbase1 seabase1 refinery1) 1)
    (engineers (forts1 camp1 airbase1 seabase1 refinery1) 3)
)
(table acp-to-repair add
    (engineers (append forts-u* base-u*) 3)
)
#|
(table material-to-create add
    (forts1 cnc 2)
    (level1-base-u* cnc 4)
    (refinery1 cnc 4)
    (forts1 bulk 2)
    (level1-base-u* bulk 8)
    (refinery1 bulk 8)
    (forts1 cmat 2)
    (level1-base-u* cmat 8)
    (refinery1 cmat 8)
)
|#
(table consumption-on-creation add
    (forts1 cnc 2)
    (level1-base-u* cnc 4)
    (refinery1 cnc 4)
    (forts1 bulk 2)
    (level1-base-u* bulk 8)
    (refinery1 bulk 8)
    (forts1 cmat 2)
    (level1-base-u* cmat 8)
    (refinery1 cmat 8)
)
(table consumption-per-build add
    (forts1 cnc 2)
    (level1-base-u* cnc 4)
    (refinery1 cnc 4)
    (forts1 bulk 2)
    (level1-base-u* bulk 8)
    (refinery1 bulk 8)
    (forts1 cmat 2)
    (level1-base-u* cmat 8)
    (refinery1 cmat 8)
)
(table material-to-repair add
    (forts-u* cnc 2.00)
    (base-u* cnc 4.00)
    (refinery-u* cnc 4.00)
    ; TODO: Reformulate cmat and bulk usage.
    (forts1 bulk 2.00)
    (level1-base-u* bulk 8.00)
    (refinery1 bulk 8.00)
    (forts1 cmat 2.00)
    (level1-base-u* cmat 8.00)
    (refinery1 cmat 8.00)
)
(table consumption-per-repair add
    (forts-u* cnc 2.00)
    (base-u* cnc 4.00)
    (refinery-u* cnc 4.00)
    ; TODO: Reformulate cmat and bulk usage.
    (forts1 bulk 2.00)
    (level1-base-u* bulk 8.00)
    (refinery1 bulk 8.00)
    (forts1 cmat 2.00)
    (level1-base-u* cmat 8.00)
    (refinery1 cmat 8.00)
)
(table create-range add
    (town specialty-facility-u* 1)
    (city specialty-facility-u* 3)
    (metropolis specialty-facility-u* 7)
    (citadel specialty-facility-u* 5)
    (capitol specialty-facility-u* 10)
    (engineers specialty-facility-u* 1)
)
(table build-range add
    (town specialty-facility-u* 1)
    (city specialty-facility-u* 3)
    (metropolis specialty-facility-u* 7)
    (citadel specialty-facility-u* 5)
    (capitol specialty-facility-u* 10)
    (engineers specialty-facility-u* 1)
)
(table auto-repair-range add
    (town specialty-facility-u* 1)
    (city specialty-facility-u* 3)
    (metropolis specialty-facility-u* 7)
    (citadel specialty-facility-u* 5)
    (capitol specialty-facility-u* 10)
)
#|
(table repair-range add
    (engineers specialty-facility-u* 1)
)
|#
(add forts-u* cp (2 0 0))
(add camp-u* cp (4 0 0))
(add airbase-u* cp (4 0 0))
(add seabase-u* cp (4 0 0))
(add refinery-u* cp (15 0))
(add forts-u* hp-max (10 75 250))
(add camp-u* hp-max (5 25 95))
(add airbase-u* hp-max (5 25 95))
(add seabase-u* hp-max (5 25 95))
(add refinery-u* hp-max (10 30))
(add refinery-u* hp-recovery (0.67 0.60))
(table cp-on-creation add
    (town specialty-facility-u* 1)
    ((city citadel) specialty-facility-u* 2)
    ((metropolis capitol) specialty-facility-u* 4)
    (engineers specialty-facility-u* 1)
)
(table cp-per-build add
    (town specialty-facility-u* 1)
    ((city citadel) specialty-facility-u* 2)
    ((metropolis capitol) specialty-facility-u* 4)
    (engineers specialty-facility-u* 1)
)
(table auto-repair add
    (town forts-u* 4.50)
    (town base-u* 1.50)
    (town refinery-u* (1.67 1.60))
    ((city citadel) forts-u* 8.95)
    ((city citadel) base-u* 2.95)
    ((city citadel) refinery1 1.67)
    ((city citadel) refinery2 1.60)
    ((metropolis capitol) forts-u* 17.95)
    ((metropolis capitol) base-u* 5.95)
    ((metropolis capitol) refinery1 1.67)
    ((metropolis capitol) refinery2 1.60)
)
(table hp-per-repair add
    (engineers forts-u* 4.50) 
    (engineers base-u* 1.50)
    ; Engineers don't touch refineries once they are built and in operation.
)

; CBR_LAND_U
(table acp-to-create add
    (indu-city-u* engineer-u* 1)
    (town germinator 0)
    (govt-city-u* spies 1)
    (camp1 (infantry truck-convoy) 1)
    (camp2 land-u* 1)
    (camp2 (append marines paratroops field-hq engineer-u*) 0)
    (camp3 land-u* 1)
    (camp3 (append marines paratroops engineer-u*) 0)
    (airbase2 (paratroops special-ops) 1)
    (airbase3 (paratroops special-ops) 1)
    (seabase2 (marines special-ops) 1)
    (seabase3 (marines special-ops) 1)
    (u* wrecks 0)
)
(table acp-to-build add
    (indu-city-u* engineer-u* 1)
    (town germinator 0)
    (govt-city-u* spies 1)
    (camp1 (infantry truck-convoy) 1)
    (camp2 land-u* 1)
    (camp2 (append marines paratroops field-hq engineer-u*) 0)
    (camp3 land-u* 1)
    (camp3 (append marines paratroops engineer-u*) 0)
    (airbase2 (paratroops special-ops) 1)
    (airbase3 (paratroops special-ops) 1)
    (seabase2 (marines special-ops) 1)
    (seabase3 (marines special-ops) 1)
    (u* wrecks 0)
)
#|
(table material-to-create add
    (land-combat-u* cnc (4 4 6 6 10 10 20 30))
    (artillery-u* cnc 6)
    (field-hq cnc 50)
    (spies cnc 40)
    (engineer-u* cnc (30 20))
    (truck-convoy cnc 2)
    (land-combat-u* recruits (2 2 2 2 2 2 2 1))
    (artillery-u* recruits 2)
    (field-hq recruits 1)
    (spies recruits 1)
    (engineer-u* recruits (0 1))
    (truck-convoy recruits 1)
    (land-combat-u* vehicles (0 2 2 2 3 0 3 1))
    (artillery-u* vehicles 2)
    (field-hq vehicles 2)
    (spies vehicles 0)
    (engineer-u* vehicles 4)
    (truck-convoy vehicles 3)
    (land-combat-u* equipment (2 2 2 2 3 2 3 1))
    (artillery-u* equipment 2)
    (field-hq equipment 2)
    (spies equipment 1)
    (engineer-u* equipment 4)
    (truck-convoy equipment 3)
)
|#
(table consumption-on-creation add
    (land-combat-u* cnc (4 4 6 6 10 10 20 30))
    (artillery-u* cnc 6)
    (field-hq cnc 50)
    (spies cnc 40)
    (engineer-u* cnc (30 20))
    (truck-convoy cnc 2)
    (land-combat-u* recruits (2 2 2 2 2 2 2 1))
    (artillery-u* recruits 2)
    (field-hq recruits 1)
    (spies recruits 1)
    (engineer-u* recruits (0 1))
    (truck-convoy recruits 1)
    (land-combat-u* vehicles (0 2 2 2 3 0 3 1))
    (artillery-u* vehicles 2)
    (field-hq vehicles 2)
    (spies vehicles 0)
    (engineer-u* vehicles 4)
    (truck-convoy vehicles 3)
    (land-combat-u* equipment (2 2 2 2 3 2 3 1))
    (artillery-u* equipment 2)
    (field-hq equipment 2)
    (spies equipment 1)
    (engineer-u* equipment 4)
    (truck-convoy equipment 3)
)
(table consumption-per-build add
    (land-combat-u* cnc (2 2 3 3 5 5 10 15))
    (artillery-u* cnc 3)
    (field-hq cnc 50)
    (spies cnc 20)
    (engineer-u* cnc (15 10))
    (truck-convoy cnc 1)
    (land-combat-u* psup (2 2 2 2 2 2 2 1))
    (artillery-u* psup 2)
    (field-hq psup 1)
    (spies psup 1)
    (engineer-u* psup (0 1))
    (truck-convoy psup 1)
    (land-combat-u* msup (2 4 4 4 6 2 6 2))
    (artillery-u* msup 4)
    (field-hq msup 4)
    (spies msup 1)
    (engineer-u* msup 8)
    (truck-convoy msup 6)
)
(table material-to-repair add
    (land-combat-u* cnc (2.00 2.00 3.00 3.00 5.00 5.00 10.00 15.00))
    (artillery-u* cnc 3.00)
    (field-hq cnc 50.00)
    (spies cnc 20.00)
    (engineer-u* cnc (15.00 10.00))
    (truck-convoy cnc 1.00)
    (land-combat-u* psup (2.00 2.00 2.00 2.00 2.00 2.00 2.00 1.00))
    (artillery-u* psup 2.00)
    (field-hq psup 1.00)
    (spies psup 1.00)
    (engineer-u* psup (0.00 1.00))
    (truck-convoy psup 1.00)
    (land-combat-u* msup (2.00 4.00 4.00 4.00 6.00 2.00 6.00 2.00))
    (artillery-u* msup 4.00)
    (field-hq msup 4.00)
    (spies msup 1.00)
    (engineer-u* msup 8.00)
    (truck-convoy msup 6.00)
    ; TODO: Add vehicles and equipment.
)
(table consumption-per-repair add
    (land-combat-u* cnc (2.00 2.00 3.00 3.00 5.00 5.00 10.00 15.00))
    (artillery-u* cnc 3.00)
    (field-hq cnc 50.00)
    (spies cnc 20.00)
    (engineer-u* cnc (15.00 10.00))
    (truck-convoy cnc 1.00)
    (land-combat-u* psup (2.00 2.00 2.00 2.00 2.00 2.00 2.00 1.00))
    (artillery-u* psup 2.00)
    (field-hq psup 1.00)
    (spies psup 1.00)
    (engineer-u* psup (0.00 1.00))
    (truck-convoy psup 1.00)
    (land-combat-u* msup (2.00 4.00 4.00 4.00 6.00 2.00 6.00 2.00))
    (artillery-u* msup 4.00)
    (field-hq msup 4.00)
    (spies msup 1.00)
    (engineer-u* msup 8.00)
    (truck-convoy msup 6.00)
    ; TODO: Add vehicles and equipment.
)
(add land-combat-u* cp (8 8 12 10 16 16 20 28))
(add artillery-u* cp 12)
(add field-hq cp 24)
(add spies cp 24)
(add engineer-u* cp (28 20))
(add truck-convoy cp 4)
(add wrecks hp-max 4)
(add land-combat-u* hp-max (20 20 24 32 24 20 28 20))
(add artillery-u* hp-max 12)
(add field-hq hp-max 8)
(add spies hp-max 4)
(add engineer-u* hp-max (4 8))
(add truck-convoy hp-max 4)
(table cp-on-creation add
    (town engineers 1)
    (city engineer-u* 2)
    (metropolis engineer-u* 4)
    (citadel spies 1)
    (capitol spies 2)
    (camp1 land-u* 1)
    (camp2 land-u* 2)
    (camp3 land-u* 4)
    (airbase2 (paratroops special-ops) 2)
    (airbase3 (paratroops special-ops) 4)
    (seabase2 (marines special-ops) 2)
    (seabase3 (marines special-ops) 4)
)
(table cp-per-build add
    (town engineers 1)
    (city engineer-u* 2)
    (metropolis engineer-u* 4)
    (citadel spies 1)
    (capitol spies 2)
    (camp1 land-u* 1)
    (camp2 land-u* 2)
    (camp3 land-u* 4)
    (airbase2 (paratroops special-ops) 2)
    (airbase3 (paratroops special-ops) 4)
    (seabase2 (marines special-ops) 2)
    (seabase3 (marines special-ops) 4)
)
(table auto-repair add
    (town engineers 0.40)
    (city engineer-u* (0.28 0.80))
    (metropolis engineer-u* (0.56 1.60))
    (citadel spies 0.16)
    (capitol spies 0.32)
    (camp1 land-combat-u* (2.50 0.00 0.00 0.00 0.00 0.00 0.00 0.00))
    (camp1 truck-convoy 1.00) 
    (camp2 land-combat-u* (5.00 5.00 4.00 6.40 0.00 0.00 2.80 1.42))
    (camp2 artillery-u* (0.00 2.00))
    (camp2 truck-convoy 2.00)
    (camp3 land-combat-u* (10.00 10.00 8.00 12.80 0.00 0.00 5.60 2.84))
    (camp3 artillery-u* 4.00)
    (camp3 field-hq 1.33)
    (camp3 truck-convoy 4.00)
    (airbase2 (paratroops special-ops) (2.50 1.42))
    (airbase3 (paratroops special-ops) (5.00 2.84))
    (seabase2 (marines special-ops) (3.00 1.42))
    (seabase3 (marines special-ops) (6.00 2.84))
)

; CBR_SEA_U
(table acp-to-create add
    (seabase1 (append boat-u* barges tugboat) 1)    
    (seabase2 sea-u* 1)
    (seabase2 (battleship submarine command-ship fleet-carrier) 0)
    (seabase3 sea-u* 1)
    (u* shipwreck 0)
)
(table acp-to-build add
    (seabase1 (append boat-u* barges tugboat) 1)    
    (seabase2 sea-u* 1)
    (seabase2 (battleship submarine command-ship fleet-carrier) 0)
    (seabase3 sea-u* 1)
    (u* shipwreck 0)
)
#|
(table material-to-create add
    (boat-u* cnc 4)
    (light-sea-combat-u* cnc 6)
    (heavy-sea-combat-u* cnc (10 40))
    (submarine cnc 20)
    (command-ship cnc 50)
    (carrier-u* cnc (6 20 40))
    (sea-transport-u* cnc (2 10 10))
    (sea-support-u* cnc 2)
    (boat-u* recruits 1)
    (light-sea-combat-u* recruits 1)
    (heavy-sea-combat-u* recruits (2 3))
    (submarine recruits 1)
    (command-ship recruits 1)
    (carrier-u* recruits (1 2 4))
    (sea-transport-u* recruits (0 1 1))
    (sea-support-u* recruits 1)
    (boat-u* bulk (1 2))
    (light-sea-combat-u* bulk 4)
    (heavy-sea-combat-u* bulk (6 10))
    (submarine bulk 2)
    (command-ship bulk 4)
    (carrier-u* bulk (4 6 10))
    (sea-transport-u* bulk (8 2 2))
    (sea-support-u* bulk (4 1))
    (boat-u* equipment (1 2))
    (light-sea-combat-u* equipment 4)
    (heavy-sea-combat-u* equipment (6 10))
    (submarine equipment 2)
    (command-ship equipment 4)
    (carrier-u* equipment (4 6 10))
    (sea-transport-u* equipment (8 2 2))
    (sea-support-u* equipment (4 1))
)
|#
(table consumption-on-creation add
    (boat-u* cnc 4)
    (light-sea-combat-u* cnc 6)
    (heavy-sea-combat-u* cnc (10 40))
    (submarine cnc 20)
    (command-ship cnc 50)
    (carrier-u* cnc (6 20 40))
    (sea-transport-u* cnc (2 10 10))
    (sea-support-u* cnc 2)
    (boat-u* recruits 1)
    (light-sea-combat-u* recruits 1)
    (heavy-sea-combat-u* recruits (2 3))
    (submarine recruits 1)
    (command-ship recruits 1)
    (carrier-u* recruits (1 2 4))
    (sea-transport-u* recruits (0 1 1))
    (sea-support-u* recruits 1)
    (boat-u* bulk (1 2))
    (light-sea-combat-u* bulk 4)
    (heavy-sea-combat-u* bulk (6 10))
    (submarine bulk 2)
    (command-ship bulk 4)
    (carrier-u* bulk (4 6 10))
    (sea-transport-u* bulk (8 2 2))
    (sea-support-u* bulk (4 1))
    (boat-u* equipment (1 2))
    (light-sea-combat-u* equipment 4)
    (heavy-sea-combat-u* equipment (6 10))
    (submarine equipment 2)
    (command-ship equipment 4)
    (carrier-u* equipment (4 6 10))
    (sea-transport-u* equipment (8 2 2))
    (sea-support-u* equipment (4 1))
)
(table consumption-per-build add
    (boat-u* cnc 2)
    (light-sea-combat-u* cnc 3)
    (heavy-sea-combat-u* cnc (5 20))
    (submarine cnc 10)
    (command-ship cnc 50)
    (carrier-u* cnc (3 10 20))
    (sea-transport-u* cnc (1 5 5))
    (sea-support-u* cnc 1)
    (boat-u* psup 1)
    (light-sea-combat-u* psup 1)
    (heavy-sea-combat-u* psup (2 3))
    (submarine psup 1)
    (command-ship psup 1)
    (carrier-u* psup (1 2 4))
    (sea-transport-u* psup (0 1 1))
    (sea-support-u* psup 1)
    (boat-u* msup (1 2))
    (light-sea-combat-u* msup 4)
    (heavy-sea-combat-u* msup (6 10))
    (submarine msup 2)
    (command-ship msup 4)
    (carrier-u* msup (4 6 10))
    (sea-transport-u* msup (8 2 2))
    (sea-support-u* msup (4 1))
)
(table material-to-repair add
    (boat-u* cnc 2.00)
    (light-sea-combat-u* cnc 3.00)
    (heavy-sea-combat-u* cnc (5.00 20.00))
    (submarine cnc 10.00)
    (command-ship cnc 50.00)
    (carrier-u* cnc (3.00 10.00 20.00))
    (sea-transport-u* cnc (1.00 5.00 5.00))
    (sea-support-u* cnc 1.00)
    (boat-u* psup 1.00)
    (light-sea-combat-u* psup 1.00)
    (heavy-sea-combat-u* psup (2.00 3.00))
    (submarine psup 1.00)
    (command-ship psup 1.00)
    (carrier-u* psup (1.00 2.00 4.00))
    (sea-transport-u* psup (0.00 1.00 1.00))
    (sea-support-u* psup 1.00)
    (boat-u* msup (1.00 2.00))
    (light-sea-combat-u* msup 4.00)
    (heavy-sea-combat-u* msup (6.00 10.00))
    (submarine msup 2.00)
    (command-ship msup 4.00)
    (carrier-u* msup (4.00 6.00 10.00))
    (sea-transport-u* msup (8.00 2.00 2.00))
    (sea-support-u* msup (4.00 1.00))
    ; TODO: Handle bulk and equipment.
)
(table consumption-per-repair add
    (boat-u* cnc 2.00)
    (light-sea-combat-u* cnc 3.00)
    (heavy-sea-combat-u* cnc (5.00 20.00))
    (submarine cnc 10.00)
    (command-ship cnc 50.00)
    (carrier-u* cnc (3.00 10.00 20.00))
    (sea-transport-u* cnc (1.00 5.00 5.00))
    (sea-support-u* cnc 1.00)
    (boat-u* psup 1.00)
    (light-sea-combat-u* psup 1.00)
    (heavy-sea-combat-u* psup (2.00 3.00))
    (submarine psup 1.00)
    (command-ship psup 1.00)
    (carrier-u* psup (1.00 2.00 4.00))
    (sea-transport-u* psup (0.00 1.00 1.00))
    (sea-support-u* psup 1.00)
    (boat-u* msup (1.00 2.00))
    (light-sea-combat-u* msup 4.00)
    (heavy-sea-combat-u* msup (6.00 10.00))
    (submarine msup 2.00)
    (command-ship msup 4.00)
    (carrier-u* msup (4.00 6.00 10.00))
    (sea-transport-u* msup (8.00 2.00 2.00))
    (sea-support-u* msup (4.00 1.00))
    ; TODO: Handle bulk and equipment.
)
(add boat-u* cp (4 8))
(add sea-combat-u* cp (12 12 20 32))
(add submarine cp 24)
(add command-ship cp 24)
(add carrier-u* cp (16 24 36))
(add sea-transport-u* cp (4 4 8))
(add sea-support-u* cp (8 4))
(add shipwreck hp-max 4)
(add boat-u* hp-max (4 8))
(add sea-combat-u* hp-max (12 12 28 48))
(add submarine hp-max 8)
(add command-ship hp-max 20)
(add carrier-u* hp-max (8 16 28))
(add sea-transport-u* hp-max (12 8 8))
(add sea-support-u* hp-max (8 4))
(table cp-on-creation add
    (seabase1 sea-u* 1)
    (seabase2 sea-u* 2)
    (seabase3 sea-u* 4)
)
(table cp-per-build add
    (seabase1 sea-u* 1)
    (seabase2 sea-u* 2)
    (seabase3 sea-u* 4)
)
(table auto-repair add
    (seabase1 boat-u* 1.00)
    (seabase1 sea-transport-u* (3.00 0.00 0.00))
    (seabase1 sea-support-u* (0.00 1.00))
    (seabase2 boat-u* 2.00)
    (seabase2 sea-combat-u* (2.00 2.00 2.80 0.00))
    (seabase2 carrier-u* (1.00 1.33 0.00))
    (seabase2 sea-transport-u* (6.00 4.00 2.00))
    (seabase2 sea-support-u* 2.00)
    (seabase3 boat-u* 4.00)
    (seabase3 sea-combat-u* (4.00 4.00 5.60 6.00))
    (seabase3 submarine 1.33)
    (seabase3 command-ship 3.33)
    (seabase3 carrier-u* (2.00 2.67 2.84))
    (seabase3 sea-transport-u* (12.00 8.00 4.00))
    (seabase3 sea-support-u* 4.00)
)

; CBR_AIR_U
(table acp-to-create add
    (airbase1 fighters 1)
    (airbase2 air-u* 1)
    (airbase2 spy-planes 0)
    (airbase3 air-u* 1) 
)
(table acp-to-build add
    (airbase1 fighters 1)
    (airbase2 air-u* 1)
    (airbase2 spy-planes 0)
    (airbase3 air-u* 1) 
)
#|
(table material-to-create add
    (fighter-u* cnc 10)
    (bomber-u* cnc 10)
    (spy-planes cnc 20)
    (cargo-planes cnc 10)
    (fighter-u* pilots 1)
    (bomber-u* pilots (1 1 2))
    (spy-planes pilots 1)
    (cargo-planes pilots 2)
    (fighter-u* vehicles 2)
    (bomber-u* vehicles 2)
    (spy-planes vehicles 1)
    (cargo-planes vehicles 2)
    (fighter-u* equipment 2)
    (bomber-u* equipment 2)
    (spy-planes equipment 1)
    (cargo-planes equipment 2)
)
|#
(table consumption-on-creation add
    (fighter-u* cnc 10)
    (bomber-u* cnc 10)
    (spy-planes cnc 20)
    (cargo-planes cnc 10)
    (fighter-u* pilots 1)
    (bomber-u* pilots (1 1 2))
    (spy-planes pilots 1)
    (cargo-planes pilots 2)
    (fighter-u* vehicles 2)
    (bomber-u* vehicles 2)
    (spy-planes vehicles 1)
    (cargo-planes vehicles 2)
    (fighter-u* equipment 2)
    (bomber-u* equipment 2)
    (spy-planes equipment 1)
    (cargo-planes equipment 2)
)
(table consumption-per-build add
    (fighter-u* cnc 10)
    (bomber-u* cnc 10)
    (spy-planes cnc 20)
    (cargo-planes cnc 10)
    (fighter-u* psup 1)
    (bomber-u* psup (1 1 2))
    (spy-planes psup 1)
    (cargo-planes psup 2)
    (fighter-u* msup 4)
    (bomber-u* msup 4)
    (spy-planes msup 2)
    (cargo-planes msup 4)
)
(table material-to-repair add
    (fighter-u* cnc 10.00)
    (bomber-u* cnc 10.00)
    (spy-planes cnc 20.00)
    (cargo-planes cnc 10.00)
    (fighter-u* psup 1.00)
    (bomber-u* psup (1.00 1.00 2.00))
    (spy-planes psup 1.00)
    (cargo-planes psup 2.00)
    (fighter-u* msup 4.00)
    (bomber-u* msup 4.00)
    (spy-planes msup 2.00)
    (cargo-planes msup 4.00)
)
(table consumption-per-repair add
    (fighter-u* cnc 10.00)
    (bomber-u* cnc 10.00)
    (spy-planes cnc 20.00)
    (cargo-planes cnc 10.00)
    (fighter-u* psup 1.00)
    (bomber-u* psup (1.00 1.00 2.00))
    (spy-planes psup 1.00)
    (cargo-planes psup 2.00)
    (fighter-u* msup 4.00)
    (bomber-u* msup 4.00)
    (spy-planes msup 2.00)
    (cargo-planes msup 4.00)
)
(add fighter-u* cp 12)
(add bomber-u* cp 12)
(add spy-planes cp 16)
(add cargo-planes cp 8)
(add fighter-u* hp-max (24 20))
(add bomber-u* hp-max (8 8 16))
(add spy-planes hp-max 4)
(add cargo-planes hp-max 8)
(table cp-on-creation add
    (airbase1 air-u* 1)
    (airbase2 air-u* 2)
    (airbase3 air-u* 4)
)
(table cp-per-build add
    (airbase1 air-u* 1)
    (airbase2 air-u* 2)
    (airbase3 air-u* 4)
)
(table auto-repair add
    (airbase1 fighters 2.00)
    (airbase2 fighter-u* (4.00 3.33))
    (airbase2 bomber-u* (1.33 1.33 2.67))
    (airbase2 cargo-planes 2.00)
    (airbase3 fighter-u* (8.00 6.67))
    (airbase3 spy-planes 1.00)
    (airbase3 cargo-planes 4.00)
)

; CBR_MINE_U
(table acp-to-create add
    (city-u* mine-u* 1)
    (ruins mine-u* 0)
    (engineers landmines 2)
    (mineship seamines 4)
)
; Mines are only created. No building required.
(table acp-to-repair add
    (city-u* mine-u* 1)
    (ruins mine-u* 0)
    (engineers landmines 1)
    (mineship seamines 2)
)
(table material-to-create add
    (mine-u* cnc 1)
    (mine-u* bulk 2)
)
(table consumption-on-creation add
    (mine-u* cnc 1)
    (mine-u* bulk 2)
)
(table material-to-repair add
    (mine-u* cnc 1.00)
    (mine-u* bulk 2.00)
)
(table consumption-per-repair add
    (mine-u* cnc 1.00)
    (mine-u* bulk 2.00)
)
(table create-range add
    (town mine-u* 1)
    (city mine-u* 3)
    (metropolis mine-u* 7)
    (citadel mine-u* 5)
    (capitol mine-u* 10)
)
#|
(table repair-range add
    (town mine-u* 1)
    (city mine-u* 3)
    (metropolis mine-u* 7)
    (citadel mine-u* 5)
    (capitol mine-u* 10)
)
|#
(add mine-u* cp 1)
(add mine-u* hp-max 6)
(table cp-on-creation add
    (u* mine-u* 1)
)
(table cp-per-build add
    ; Forbid building. Should be unnecessary.
    (u* mine-u* 0)
)
(table hp-per-repair add
    (city-u* mine-u* 6.00)
    (engineers landmines 3.00)
    (mineship seamines 3.00)
)

; Dmg/HP Quanta
#|
    footsoldiers  1.5 hp/hit  x  10 hits  =  20 hp
    armor         7.5 hp/hit  x  4 hits  =  32 hp
    footsoldiers would need 21+ hits to destroy armor
    armor would need 2+ hits to destroy footsoldiers

    destroyer     1.5 hp/hit  x  6 hits  =  12 hp
    battleship    7.5 hp/hit  x  6 hits  =  48 hp
    destroyer would need 32 hits to destroy battleship
    battleship would need 1+ hits to destroy destroyer
|#

; VISB_GENERAL
(table visibility
    ; Default: 100%
)

; VISB_CITY_U
(add city-u* see-always true)
(table visibility add
    (ruins (forest mountains) 50%)
)

; VISB_FACILITY_U
(add specialty-facility-u* see-always true)
(table visibility add
    (forts-u* (forest mountains) 50%)
    (camp1 (forest mountains) 50%)
)

; VISB_LAND_U
(add wrecks see-always true)
(table visibility add
    (land-u* (forest mountains) 50%)
    (land-u* road 300%)
    (footsoldier-u* swamp 75%)
    (footsoldier-u* (forest mountains) 25%)
    (special-ops (forest mountains glaciers) 5%)
    (spies road 100%)
)

; VISB_SEA_U
(add shipwreck see-always true)

; VISB_AIR_U
; No air units have any special visibility properties.

; VISB_MINE_U
(add mine-u* see-always true)

; VISN_GENERAL
(table see-chance-at
    ; Default: 100%
    (u* u* BA_NEVER)
)
(table see-chance-adjacent
    ; Default: 100%
    (u* u* BA_NEVER)
)
(table see-chance
    ; Default: 100%
    (u* u* BA_NEVER)
)
(table occupant-vision
    ; Default: 100%
    (u* u* 0%)
)
; Rely on general vision range rather than tracking. Exception: spies.
(table track-chance
    ; Default: 0/10000
)
(table lose-track-chance
    ; Default: 0/10000
)
(table spy-quality
    ; Default: 0%
)
(table spy-track-chance
    ; Default: 0/10000
)

; VISN_CITY_U
(add city-u* vision-range (0 1 3 7 5 10))
(table see-chance-at add
    (city-u* u* BA_ALWAYS)
    (ruins u* BA_NEVER)
)
(table see-chance-adjacent add
    (city-u* facility-u* BA_ALWAYS)
    (city-u* land-u* BA_ALWAYS)
    (indu-city-u* special-ops (BA_VERY_UNLIKELY BA_UNLIKELY BA_LIKELY))
    (govt-city-u* special-ops (BA_5050 BA_VERY_LIKELY))
    (city-u* sea-u* BA_ALWAYS)
    (city-u* submarine BA_NEVER)
    (city-u* air-u* BA_ALWAYS)
    (indu-city-u* spy-planes (BA_VERY_UNLIKELY BA_UNLIKELY BA_5050))
    (govt-city-u* spy-planes (BA_5050 BA_LIKELY))
    (city-u* mine-u* BA_ALWAYS)
    (ruins u* BA_NEVER)
)
(table see-chance add
    (city-u* facility-u* BA_ALWAYS)
    (city-u* land-u* BA_ALWAYS)
    (indu-city-u* special-ops (BA_NEVER BA_VERY_UNLIKELY BA_UNLIKELY))
    (govt-city-u* special-ops (BA_UNLIKELY BA_5050))
    (city-u* sea-u* BA_ALWAYS)
    (city-u* submarine BA_NEVER)
    (indu-city-u* spy-planes (BA_NEVER BA_VERY_UNLIKELY BA_VERY_UNLIKELY))
    (govt-city-u* spy-planes (BA_VERY_UNLIKELY BA_UNLIKELY))
    (city-u* mine-u* BA_VERY_LIKELY)
    (ruins u* BA_NEVER)
)

; VISN_FACILITY_U
(add forts-u* vision-range 0)
(add level1-base-u* vision-range 1)
(add level2-base-u* vision-range 2)
(add level3-base-u* vision-range 3)
(add refinery-u* vision-range 0)
(table see-chance-at add
    (specialty-facility-u* u* BA_ALWAYS)
    (forts-u* u* BA_NEVER)
)
(table see-chance-adjacent add
    (specialty-facility-u* u* BA_ALWAYS)
    (specialty-facility-u* (special-ops submarine spy-planes) BA_NEVER)
    (camp2 special-ops BA_5050)
    (airbase2 spy-planes BA_5050)
    (seabase2 submarine BA_5050)
    (camp3 special-ops BA_LIKELY)
    (airbase3 spy-planes BA_LIKELY)
    (seabase3 submarine BA_LIKELY)
    (forts-u* u* BA_NEVER)
    (refinery-u* u* BA_NEVER)
)
(table see-chance add
    (specialty-facility-u* u* BA_ALWAYS)
    (specialty-facility-u* (special-ops submarine spy-planes) BA_NEVER)
    (camp2 special-ops BA_VERY_UNLIKELY)
    (airbase2 spy-planes BA_VERY_UNLIKELY)
    (seabase2 submarine BA_VERY_UNLIKELY)
    (camp3 special-ops BA_UNLIKELY)
    (airbase3 spy-planes BA_UNLIKELY)
    (seabase3 submarine BA_UNLIKELY)
    (forts-u* u* BA_NEVER)
    (level1-base-u* u* BA_NEVER)
    (refinery-u* u* BA_NEVER)
)

; VISN_LAND_U
(add wrecks vision-range -1)
(add land-combat-u* vision-range (2 2 4 2 4 2 4 4))
(add artillery-u* vision-range (4 2))
(add field-hq vision-range 4)
(add spies vision-range 10)
(add engineer-u* vision-range 2)
(add truck-convoy vision-range 2)
(add spies spy-range 15)
(add spies spy-chance BA_VERY_LIKELY)
(table occupant-vision add
    (land-u* facility-u* 100%)
)
(table see-chance-at add
    (land-u* u* BA_ALWAYS)
    (land-u* spies BA_UNLIKELY)
    (land-u* submarine BA_NEVER)
    (wrecks u* BA_NEVER)
)
(table see-chance-adjacent add
    (land-u* facility-u* BA_ALWAYS)
    (land-u* forts1 BA_5050)
    (land-u* land-u* BA_LIKELY)
    (land-u* footsoldier-u* BA_5050)
    (land-u* special-ops BA_VERY_UNLIKELY)
    (land-u* spies BA_NEVER)
    (land-u* sea-u* BA_5050)
    (land-u* small-sea-u* BA_UNLIKELY)
    (land-u* submarine BA_NEVER)
    (land-u* air-u* BA_LIKELY)
    (land-u* spy-planes BA_VERY_UNLIKELY)
    (wrecks u* BA_NEVER)
)
(table see-chance add
    (land-u* facility-u* BA_ALWAYS)
    (land-u* forts1 BA_VERY_UNLIKELY)
    (land-u* forts2 BA_LIKELY)
    (land-u* land-u* BA_5050)
    (land-u* footsoldier-u* BA_UNLIKELY)
    (land-u* special-ops BA_NEVER)
    (land-u* spies BA_NEVER)
    (land-u* sea-u* BA_UNLIKELY)
    (land-u* small-sea-u* BA_VERY_UNLIKELY)
    (land-u* submarine BA_NEVER)
    (land-u* air-u* BA_5050)
    (land-u* spy-planes BA_NEVER)
    (wrecks u* BA_NEVER)
)
(table spy-quality add
    (spies facility-u* BA_ALWAYS)
    (spies (append land-u* sea-u* air-u*) BA_5050)
    (spies spies BA_UNLIKELY)
    (spies mine-u* BA_UNLIKELY)
)
(table spy-track-chance add
    (spies (append land-u* sea-u* air-u*) 2500)
    (spies spies 5000)
)

; VISN_SEA_U
(add shipwreck vision-range -1)
(add boat-u* vision-range 2)
(add light-sea-combat-u* vision-range 5)
(add heavy-sea-combat-u* vision-range (5 7))
(add command-ship vision-range 5)
(add carrier-u* vision-range (5 5 7))
(add sea-transport-u* vision-range 2)
(add sea-support-u* vision-range 2)
(table occupant-vision add
    (sea-u* facility-u* 50%)
)
(table see-chance-at add
    (sea-u* u* BA_ALWAYS)
    (sea-u* spies BA_UNLIKELY)
    (shipwreck u* BA_NEVER)
)
(table see-chance-adjacent add
    (sea-u* facility-u* BA_ALWAYS)
    (sea-u* forts1 BA_VERY_UNLIKELY)
    (sea-u* forts2 BA_UNLIKELY)
    (sea-u* land-u* BA_UNLIKELY)
    (sea-u* footsoldier-u* BA_VERY_UNLIKELY)
    (sea-u* special-ops BA_NEVER)
    (sea-u* spies BA_NEVER)
    (sea-radar-u* sea-u* BA_ALWAYS)
    (sea-non-radar-u* sea-u* BA_LIKELY)
    (sea-non-radar-u* small-sea-u* BA_5050)
    (sea-u* submarine BA_NEVER)
    (destroyer submarine BA_5050)
    (submarine submarine BA_5050)
    (sea-u* air-u* BA_LIKELY)
    (sea-u* spy-planes BA_VERY_UNLIKELY)
    (shipwreck u* BA_NEVER)
)
(table see-chance add
    (sea-u* facility-u* BA_ALWAYS)
    (sea-u* forts1 BA_NEVER)
    (sea-u* forts2 BA_VERY_UNLIKELY)
    (sea-u* land-u* BA_NEVER)
    (sea-radar-u* sea-u* BA_LIKELY)
    (sea-non-radar-u* sea-u* BA_UNLIKELY)
    (sea-non-radar-u* small-sea-u* BA_VERY_UNLIKELY)
    (sea-u* submarine BA_NEVER)
    (sea-u* air-u* BA_5050)
    (sea-u* spy-planes BA_NEVER)
    (shipwreck u* BA_NEVER)
)

; VISN_AIR_U
(add fighter-u* vision-range 7)
(add bomber-u* vision-range (7 7 10))
(add spy-planes vision-range 15)
(add cargo-planes vision-range 7)
(table see-chance-at add
    (air-u* u* BA_ALWAYS)
    (air-u* spies BA_NEVER)
    (air-u* submarine BA_NEVER)
)
(table see-chance-adjacent add
    (air-u* facility-u* BA_ALWAYS)
    (air-u* land-u* BA_VERY_LIKELY)
    (spy-planes land-u* BA_ALWAYS)
    (air-u* footsoldier-u* BA_LIKELY)
    (air-u* special-ops BA_5050)
    (air-u* spies BA_NEVER)
    (air-u* sea-u* BA_VERY_LIKELY)
    (spy-planes sea-u* BA_ALWAYS)
    (air-u* small-sea-u* BA_LIKELY)
    (spy-planes small-sea-u* BA_VERY_LIKELY)
    (air-u* submarine BA_NEVER)
    (air-u* air-u* BA_VERY_LIKELY)
)
(table see-chance add
    (air-u* facility-u* BA_ALWAYS)
    (air-u* forts1 BA_LIKELY)
    (spy-planes forts1 BA_ALWAYS)
    (air-u* land-u* BA_LIKELY)
    (spy-planes land-u* BA_VERY_LIKELY)
    (air-u* footsoldier-u* BA_UNLIKELY)
    (air-u* special-ops BA_NEVER)
    (air-u* spies BA_NEVER)
    (air-u* sea-u* BA_LIKELY)
    (spy-planes sea-u* BA_VERY_LIKELY)
    (air-u* small-sea-u* BA_5050)
    (spy-planes small-sea-u* BA_LIKELY)
    (air-u* submarine BA_NEVER)
    (air-u* air-u* BA_LIKELY)
)

; VISN_MINE_U
(add mine-u* vision-range -1)

;; Ovid's Metamorphoses

; TALT_GENERAL
(table acp-to-add-terrain
    ; Default: 0
)
(table acp-to-remove-terrain
    ; Default: 0
)
(table material-to-add-terrain
    ; Default: 0
    (u* cnc 4)
)
(table material-to-remove-terrain
    ; Default: 0
    (u* cnc 2)
)
(table consumption-per-add-terrain
    ; Default: 0
    (road bulk 10)
    (road cmat 4)
)
(table material-per-remove-terrain
    ; Default: 0
)
(table alter-terrain-range
    ; Default: 0
)

; TALT_CITY_U
(table acp-to-add-terrain add
    (city-u* road 1)
    (ruins road 0)
)
(table acp-to-remove-terrain add
    (city-u* road 1)
    (ruins road 0)
)
(table alter-terrain-range add
    (town road 1)
    (city road 3)
    (metropolis road 7)
    (citadel road 5)
    (capitol road 10)
)

; TALT_FACILITY_U
; No facilities perform terrain alterations.

; TALT_LAND_U
(table acp-to-add-terrain add
    (engineers road 3)
)
(table acp-to-remove-terrain add
    (special-ops road 6)
    (artillery-u* road (4 6))
    (engineers road 3)
)
(table alter-terrain-range add
    (artillery-u* road (1 2))
)

; TALT_SEA_U
; No sea units perform terrain alterations.

; TALT_AIR_U
(table acp-to-remove-terrain add
    ((dive-bombers bombers) road 12)
)

; TALT_MINE_U
; No mine units perform terrain alterations.

; HAZ_GENERAL
(table vanishes-on
    ; Default: false
    (u* t* true)
)
(table wrecks-on
    ; Default: false
    (u* t* true)
)

; HAZ_CITY_U
(table vanishes-on add
    (city-u* land-t* false)
)
(table wrecks-on add
    (city-u* land-t* false)
)

; HAZ_FACILITY_U
(table vanishes-on add
    (specialty-facility-u* land-t* false)
    (seabase-u* land-t* true)
    (seabase-u* coast false)
)
(table wrecks-on add
    (specialty-facility-u* land-t* false)
    (seabase-u* land-t* true)
    (seabase-u* coast false)
)

; HAZ_LAND_U
(table vanishes-on add
    (land-u* land-t* false)
    (land-u* road false)
    ((append cavalry armor stormtroops artillery-u*) swamp true)
    (marine-land-u* (coast lake river) false)
)
(table wrecks-on add
    (land-u* land-t* false)
    (land-u* road false)
    (marine-land-u* (coast lake river) false)
)

; HAZ_SEA_U
(table vanishes-on add
    (sea-u* water-t* false)
    (small-sea-u* river false)
)
(table wrecks-on add
    (sea-u* water-t* false)
    (small-sea-u* river false)
    (xlarge-sea-u* (coast lake) true)
)

; HAZ_AIR_U
(table vanishes-on add
    (air-u* t* false)
    (air-u* barrier true)
)
(table wrecks-on add
    (air-u* t* false)
    (air-u* barrier true)
)

; HAZ_MINE_U
(table vanishes-on add
    (landmines (append land-t* road) false)
    (seamines water-t* false)
)
(table wrecks-on add
    (landmines (append land-t* road) false)
    (seamines water-t* false)
)

; CHNG_GENERAL
(table can-change-type-to
    ; Default: false
)
(table acp-to-change-type
    ; Default: 0
)
(table material-to-change-type
    ; Default: 0
)
(table unit-consumption-to-grow 
    ; Default: 0
)
(table size-to-change-type
    ; Default: 0
)
(table size-limit-without-occupant
    ; Default: TABHI
)
(table cxp-to-change-type
    ; Default: 0
)
(table occupants-to-change-type
    ; Default: 0
)
(table turn-to-change-type
    ; Default: 0
)

; CHNG_CITY_U
(table can-change-type-to add
    (ruins town true)
    (ruins citadel true)
)
(table acp-to-change-type add
    (ruins town 1)
    (ruins citadel 1)
)
(add (ruins town city) auto-upgrade-to (town city metropolis))
(add citadel auto-upgrade-to capitol)
(add (metropolis city town) wrecked-type (city town ruins))
(add (capitol citadel) wrecked-type (citadel ruins))
#|
(table unit-consumption-to-grow add
    (ruins cmat 2)
    ; Other city types are self-sufficient wrt growth materials.
)
|#
(table size-limit-without-occupant add
    (ruins germinator 1)
    ; Other city types grow without Germinators.
)
(table size-to-change-type add
    (ruins (town citadel) (30 60))
    (town city 75)
    (city metropolis 225)
    (citadel capitol 240)
)

; CHNG_FACILITY_U
(add (forts1 forts2) auto-upgrade-to (forts2 forts3))
(add (camp1 camp2) auto-upgrade-to (camp2 camp3))
(add (airbase1 airbase2) auto-upgrade-to (airbase2 airbase3))
(add (seabase1 seabase2) auto-upgrade-to (seabase2 seabase3))
(add refinery1 auto-upgrade-to refinery2)
(add (forts3 forts2) wrecked-type (forts2 forts1))
(add (camp3 camp2) wrecked-type (camp2 camp1))
(add (airbase3 airbase2) wrecked-type (airbase2 airbase1))
(add (seabase3 seabase2) wrecked-type (seabase2 seabase1))
(add refinery2 wrecked-type refinery1)
; TODO: Consider adding material-to-change-type.
#|
(table unit-consumption-to-grow add
    (refinery1 bulk 1)
    ((forts1 camp1 airbase1 seabase1 refinery1) cmat 1)
    ((forts2 camp2 airbase2 seabase2) cmat 1)
)
|#
(table size-limit-without-occupant add
    (forts-u* engineers (1 15 50))
    (level1-base-u* engineers 1)
    (level2-base-u* engineers 20)
    (level3-base-u* engineers 75)
    ; Refineries do not need Engineers to grow.
)
(table size-to-change-type add
    (forts1 forts2 15) (forts2 forts3 50)
    (camp1 camp2 20) (camp2 camp3 75)
    (airbase1 airbase2 20) (airbase2 airbase3 75)
    (seabase1 seabase2 20) (seabase2 seabase3 75)
    (refinery1 refinery2 50)
)

; CHNG_LAND_U
(add (append light-land-combat-u* heavy-land-combat-u*) wrecked-type wrecks)
(add artillery-u* wrecked-type wrecks)
(add field-hq wrecked-type wrecks)
(add engineer-u* wrecked-type wrecks)
(add truck-convoy wrecked-type wrecks) 

; CHNG_SEA_U
(add (append large-sea-u* xlarge-sea-u*) wrecked-type shipwreck)

; CHNG_AIR_U
; No change types for aircraft.

#|
(set action-notices '(
    ((destroy u* facility-u*) (actor " demolishes " actee "!"))
    ((destroy u* land-u*) (actor " breaks and disperses " actee "!"))
    ((destroy u* sea-u*) (actor " sinks " actee "!"))
    ((destroy u* air-u*) (actor " blasts " actee " out of the sky!"))
    ((destroy u* mine-u*) (actor " totally clears " actee "."))
    ((disband (ruins shipwreck) self done) (actor " is cleared out."))
    ((disband mine-u* self done) (actor " is totally cleared."))
    (
        (capture paratroops facility-u*)
        (actor " storms and captures " actee "!")
    )
    (
        (liberate paratroops facility-u*)
        (actor " storms and liberates " actee "!")
    )
    (
        (capture (cavalry armor) facility-u*)
        (actor " overwhelms and captures " actee "!")
    )
    (
        (hit (infantry mechinf marines paratroops) facility-u*)
        (actor " shoots up " actee ".")
    )
    (
        (hit (cavalry armor artillery aaa) facility-u*)
        (actor " volleys fire upon " actee ".")
    )
    (
        (hit (dive-bombers bombers) facility-u*)
        (actor " rains bombs upon " actee ".")
    )
    ((hit (fighters efighters) land-u*) (actor " strafes " actee "."))
    ((hit (dive-bombers bombers) land-u*) (actor " bombs " actee "."))
    ((hit (torp-boats torp-bombers) sea-u*) (actor " torpedoes " actee "."))
    ((hit (dive-bombers bombers) sea-u*) (actor " bombs " actee "."))
))

(set event-notices '(
    ((unit-starved infantry) (0 " is disbanded by illness and starvation!"))
    ((unit-starved mechinf) (0 " is disbanded by illness and starvation!"))
    ((unit-starved cavalry) (0 " is disbanded by illness and starvation!"))
    ((unit-starved armor) (0 " is disbanded by illness and starvation!"))
    ((unit-starved marines) (0 " is disbanded by illness and starvation!"))
    ((unit-starved paratroops) (0 " is disbanded by illness and starvation!"))
    ((unit-starved aaa) (0 " is disbanded by illness and starvation!"))
    ((unit-starved artillery) (0 " is disbanded by illness and starvation!"))
    ((unit-starved field-hq) (0 " is disbanded by illness and starvation!"))
    ((unit-starved germinator) (0 " is disbanded by illness and starvation!"))
    ((unit-starved engineers) (0 " is disbanded by illness and starvation!"))
    ((unit-starved cargo-planes) (0 " runs out of fuel and crashes!"))
    ((unit-starved fighters) (0 " runs out of fuel and crashes!"))
    ((unit-starved efighters) (0 " runs out of fuel and crashes!"))
    ((unit-starved dive-bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved torp-bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved bombers) (0 " runs out of fuel and crashes!"))
    ((unit-starved spy-planes) (0 " runs out of fuel and crashes!"))
))

(set event-narratives '(
    ((unit-starved infantry) (0 " was disbanded by illness and starvation!"))
    ((unit-starved mechinf) (0 " was disbanded by illness and starvation!"))
    ((unit-starved cavalry) (0 " was disbanded by illness and starvation!"))
    ((unit-starved armor) (0 " was disbanded by illness and starvation!"))
    ((unit-starved marines) (0 " was disbanded by illness and starvation!"))
    ((unit-starved paratroops) (0 " was disbanded by illness and starvation!"))
    ((unit-starved aaa) (0 " was disbanded by illness and starvation!"))
    ((unit-starved artillery) (0 " was disbanded by illness and starvation!"))
    ((unit-starved field-hq) (0 " was disbanded by illness and starvation!"))
    ((unit-starved germinator) (0 " was disbanded by illness and starvation!"))
    ((unit-starved engineers) (0 " was disbanded by illness and starvation!"))
    ((unit-starved cargo-planes) (0 " ran out of fuel and crashed!"))
    ((unit-starved fighters) (0 " ran out of fuel and crashed!"))
    ((unit-starved efighters) (0 " ran out of fuel and crashed!"))
    ((unit-starved dive-bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved torp-bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved bombers) (0 " ran out of fuel and crashed!"))
    ((unit-starved spy-planes) (0 " ran out of fuel and crashed!"))
))

|#

(table acp-occupant-effect
    ; Default: 100%
)
